<?php
/**
 * This controller facilitates the access of table job_definitions
 * 
 *
 * @package    	HRM\controller\job_definitions
 * @version    	1.0
 * @copyright  	2016, BizyCorp Internal Systems Development
 * @license    	private, All rights reserved
 * @author     	CIGen (Automated CI Code Generator)
 * 
 */

if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * This file contains CI controller for CI Code Generation
 * 
 * 
 * This class contains the following functions
 *
 *  1) function index() , can be used to retrieve data from the table with filteration
 *	2) function save() , can be used to add / update data
 *	3) function key_validate() , used to validate the primary key of the table
 *	4) function delete() , used to delete a record
 *	5) function loadForm(), used to load the forms
 *	6) public function createDropdown(), generates the dropdown
 *	7) function loadWB(), initiates the workbench
 *
 * @package     HRM\controller\Job_definitions_external
 * @version		1.0
 * @uses		
 * @see			
 * @copyright	2016, BizyCorp Internal Systems Development
 * @license		private, All rights reserved
 * @author		CIGen (Automated CI Code Generator)
 * @created    	Mar 25, 2016
 * @modified   	Mar 25, 2016
 * @modified   	Jan 22, 2020 Thilan Jayasinghe
 * @modification 
 */
class Job_definitions_external extends CI_Controller{
	
	/**
	 * AIR related vars
	 * Default request method
	 * @var $request_method
	 */
	private $request_method = 'get'; 

	/**
	 * AIR related vars
	 * This is reffering to the token which is received from calling app.
	 * @var $received_token
	 */
	private $received_token = null;  
	
	/**
	 * AIR related vars
	 * Default This is reffering to the token whic is generated and obtained from AIR directly
	 * @var $token
	 */
	private $token 			= null; 

	/**
	 * AIR related vars
	 * $AIR_call_flag
	 * @var $AIR_call_flag
	 */
	private $AIR_call_flag 	= false;
	
	/**
	 * AIR related vars
	 * debug
	 * @var $debug
	 */
	private $debug 			= true;  
	
	/**
	 * AIR related vars
	 * AR_Utilities
	 * @var $AR_Utilities
	 */
	private $AR_Utilities 	= null;

	/**
	 * Common vars
	 * User Name
	 * @var $user_name
	 */
	private $user_name='';	
	
	/**
	 * Common vars
	 * User id
	 * @var $user_id
	 */
	private $user_id='';
	
	/**
	 * Common vars
	 * User email
	 * @var $user_email
	 */
	private $user_email='';
	
	/**
	 * Common vars
	 * User Type
	 * @var $user_type
	 */
	private $user_type='';
	
	/**
	 * Common vars
	 * Log Object instance
	 * @var $log_create
	 */
	private $log_create='';
	
	/**
	 * Function __construct
	 * 
	 *
	 * The constructor function
	 * 
	 * @param	None
	 * @return	void
	 * @access	
	 * @since	1.0
	 */
    function __construct(){
    	//echo "constructtor";
    	parent::__construct();
    //	$_SESSION["user_name"]="";
    //	$_SESSION["user_type"]="";
    //	$_SESSION["user_id"]="";
    		$this->user_name='';
    		$this->user_type='';
    		$this->user_id='';
    		//$this->user_email='';
    	
    	$this->log_create = new log_object();
    	$this->log_create->set_disable($this->config->item('log_status'));
    	$this->log_create->set_userDetails($this->user_name, $this->user_type);
    	
    	/* Init AIR Lib=========================================================== */
        // Load AR_Utilities library only if an external call is made on this controller.
       // $this->load->library('AR_Utilities');
       // $this->AR_Utilities = new AR_Utilities("called_app");
       // if($this->AR_Utilities->validityStatus['validity'] == 'VALID'){
        //	$this->AIR_call_flag = true;
       // }
        
        $this->load->model('job_definitions_model');
        
       // @session_start();
        staff_array();
       // $arrydata= staff_array();
       // print_r($arrydata);
	}//end of construct__
	
		
	/**
	 * Function set_external_session_vars()
	 * 
	 *
	 * This method is be executed for extra function definitions to be implemented when AIR token verification
	 * is done.
	 * This function is executed by AIR_Utilities class upon successfull token verification
	 *
	 * @param	None
	 * @return	void
	 * @access	public
	 * @since	1.0
	 */
	public function set_external_session_vars(){
		// You can specify custome session variables soon after AIR call and token is verified.
		// By default after token verification, necessessary UAACS session vars get initiated inside AR_Utilities class. 
		// This method can be used to initiate additional session vars if needed
		
		// example usage
		// $_SESSION['Test_Session_1'] = 'This is a test session';
	}//end of set_txternal_session_vars();
	
	/**
	 * Function index()
	 * 
	 *
	 * @param $search, Boolean value whether search is enable or not
	 * @param $limit, Limit of record set
	 * @param $offset, Offset of record set
	 * @param $file , view file
	 * @param $format , format of the out put
	 * @param $collist, to pass the column filter to the view columns are sent as
	 *        col01:col02:...:coln and is pased to view as an array of col names
	 *        (Added by WCD on 31/7/13)
	 * @param $widths to pass the column widths to the view, widths are sent as col1=10:col2=25.... to the controller
	 * 		  controller will pass the width as array to the view
	 * 		  array('col1'=>10,'col2'=>25)
	 * @param $visibilityList, pass the visibility list to the view, list should be sent col1=true:col2=false ... to the controller 
	 * 		  and the contorller will process the param and construct an array as 
	 *        array(col1=>true,col2=>true,col3=>false)) and pass it to the view
     * @param $cellStyles, pass the cell styles list to the view, list should be sent text-align:center_text-align:center_text-align:left ... to the controller 
     * 		  and the contorller will process the param and construct an array as 
     *        array(text-align:center,text-align:center,text-align:center) and pass it to the view
     *        
	 * Data from view :
	 * Use $_REQUEST
	 * Filed names are like :  filed_name_querymethod
	 *
	 * Send to Model : Array of data
	 * ex: Array('search' => $searchobj_array,'limit' => $limit,'offset'=>$offset)
	 * 
	 * Note : $searchobj_array is a array consist of set of objects.
	 * ex: $searchobj_array = array([0]=>array('search_filed'=>'name','search_text'=>'sara','query_method'=>'like'),[1]=>array('search_filed'=>'country','search_text'=>'srilanka','query_method'=>'equel'))
	 * @return  the data feed
	 * @access	public
 	 * @since	1.0
 	 * 
	 */
	function index($search=FALSE,$limit=0,$offset=0,$file='data_feed_template',$format='',$collist='',$widths='',$visibilityList='',$cellStyles=''){	
		$debug = false;
		$this->log_create->set_otherDetails(array('Mode'=>'view','Data'=>'QUERY- STRING:'.count($_POST)>0?serialize($_POST):serialize($_GET)));
		$this->log_create->init();
		
		if($search==true){
			$searchobj_array = array();
			
			foreach((count($_POST)>0?$_POST:$_GET) as $key => $val){
				$search_text=$val; //search text
				$pos = strrpos($key, '_');
				$query_method = substr($key,$pos+1);
				$field= substr($key, 0, $pos);
				
				//if filed has '.'
				$field = str_replace('/','.',$field);
				//log_message('info',"\$field :- $field");
				
				$search_obj= array('search_field' => $field, 'search_text' => $search_text,'query_method'=>$query_method);
				array_push($searchobj_array, $search_obj);
			}
			
			$data['dataset'] = $this->job_definitions_model->get_data(array('search'=>$searchobj_array,'limit' => $limit,'offset'=>$offset,'order_by'=>array('job_definitions.id'=>'Desc')));
		}else {
			$data['dataset'] = $this->job_definitions_model->get_data(array('limit' => $limit,'offset'=>$offset,'order_by'=>array('job_definitions.id'=>'Desc')));
		}
		
		$staff_array = staff_array();//get_staff_array();
		$worktypes_array = get_worktype_array('true/0/0/data_feed_template/XML/0/0/0/1');
		$jobprofile_array = get_job_profile_array('true/0/0/data_feed_template/XML');
		
		$i=1;
		foreach($data['dataset']['result_set'] as $row){
			$v2 = null;
			foreach($row as $k => $v){
				switch ($k){
					case 'advertorial':
						$v2 = $this->limit_strings($v, 0,$row['id'].'|||'.$k);
						$row[$k] = $v2;
					break;
					case 'offer_template':
						$v2 = $this->limit_strings($v, 0,$row['id'].'|||'.$k);
						$row[$k] = $v2;
					break;
					case 'rules_template':
						$v2 = $this->limit_strings($v, 0,$row['id'].'|||'.$k);
						$row[$k] = $v2;
					break;
					case 'trade_test':
						$v2 = $this->limit_strings($v, 0,$row['id'].'|||'.$k);
						$row[$k] = $v2;
					break;
					case 'intview_guide':
						$v2 = $this->limit_strings($v, 0,$row['id'].'|||'.$k);
						$row[$k] = $v2;
					break;
					case 'Remarks':
						$v2 = $this->limit_strings($v, 0,$row['id'].'|||'.$k);
						$row[$k] = $v2;
					break;
					case 'manager_id':
						foreach($staff_array as $staff){
							$id = $staff['staff_id'];
							$full_name = $staff['full_name'];
							if($id == $v){ $row[$k] = $full_name; }
						}
					break;
					case 'work_type':
						$v_arr = null;
						$v_arr = explode(',',$v);
						$row[$k] = null;
						if($debug) log_message('debug',"index() switch case after explode work_type:".print_r($v_arr,true));
						foreach($v_arr as $wt_item){
							if($debug) log_message('debug',"index() wt_item:".print_r($wt_item,true));
							foreach($worktypes_array as $wt){
								//if($debug) log_message('debug',"index() what is wt:".print_r($wt,true));
								$id = $wt["@attributes"]["id"];
								$worktype= $wt['cell'][0];
								if($id == $wt_item){
									$row[$k] .= $worktype.'<br>';
								}
							}
						}
						if($debug) log_message('debug',"index() work_type full array:".print_r($row[$k],true));
					break;
					case 'job_profile':
						$v_arr = null;
						$v_arr = explode(',',$v);
						$row[$k] = null;
						if($debug) log_message('debug',"index() switch case after explode job_profilelist:".print_r($v_arr,true));
						foreach($v_arr as $jp_item){
							if($debug) log_message('debug',"index() jp_item:".print_r($jp_item,true));
							foreach($jobprofile_array as $jp){
								//if($debug) log_message('debug',"index() what is wt:".print_r($wt,true));
								$id = $jp["@attributes"]["id"];
								$jobprofile= $jp['cell'][2];
								if($id == $jp_item){
									$row[$k] .= $jobprofile.'<br>';
								}
							}
						}
						if($debug) log_message('debug',"index() work_type full array:".print_r($row[$k],true));
					break;
					case 'new_app_alert':
						//replace ',' with <br> for line break
						$v = str_replace(',','<br>',$v);
						$row[$k]=  $v;
					break;
					case 'test_alert':
						//replace ',' with <br> for line break
						$v = str_replace(',','<br>',$v);
						$row[$k]=  $v;
					break;
					case 'intviw_alert':
						//replace ',' with <br> for line break
						$v = str_replace(',','<br>',$v);
						$row[$k]=  $v;
					break;
					case 'gen_alert':
						//replace ',' with <br> for line break
						$v = str_replace(',','<br>',$v);
						$row[$k]=  $v;
					break;
					default:
						$row[$k] = $v;
					break;
				}
			}
			$data['dataset']['result_set'][$i] = $row;
			$i++;
		}
		$wrapped_data['data'] = $data;
		$wrapped_data['format'] = $format;
		$wrapped_data['searchOn'] = $search;
		
		$wrapped_data['collist'] = $collist ? explode(':',$collist) : array(
            'designation', 'work_type', 'accountability', 'job_profile', 'probation_period', 'probation_rate', 'confirmed_rate',
            'currency', 'manager_name', 'hire_lead_time', 'Status', 'min_work_hrs', 'max_work_hrs', 'new_app_alert', 'test_alert',
            'intviw_alert', 'gen_alert',            		
		);
		
		if($widths !="0" && $widths !=""){
			$widthsPara = explode(':',$widths);
			foreach ($widthsPara as $val ){
				$split =  explode('=',$val);
				$widths_arr[$split[0]]= $split[1];
			}
		}
		$wrapped_data['widths'] = $widths ? $widths_arr : array(
        	'designation'=>200, 'work_type'=>200, 'accountability'=>150, 'job_profile'=>150, 'probation_period'=>100, 'probation_rate'=>100,
            'confirmed_rate'=>100, 'currency'=>100, 'manager_name'=>150, 'hire_lead_time'=>150, 'Status'=>100, 'min_work_hrs'=>100,
            'max_work_hrs'=>100, 'new_app_alert'=>150, 'test_alert'=>150, 'intviw_alert'=>150, 'gen_alert'=>150,
		);
		
		if($visibilityList !="0" && $visibilityList !=""){
			$visibilityListPara = explode(':',$visibilityList);
			foreach ($visibilityListPara as $val){
				$split =  explode('=',$val);
				$visibilityList_arr[$split[0]]= $split[1];
			}
		}
		$wrapped_data['visibilityList'] = $visibilityList ? $visibilityList_arr : array(
			'designation'=>true, 'work_type'=>true, 'accountability'=>true, 'job_profile'=>true, 'probation_period'=>true,
			'probation_rate'=>true, 'confirmed_rate'=>true, 'currency'=>true, 'manager_name'=>true, 'hire_lead_time'=>true, 'Status'=>true, 
			'min_work_hrs'=>true, 'max_work_hrs'=>true, 'new_app_alert'=>true, 'test_alert'=>true, 'intviw_alert'=>true, 'gen_alert'=>true
		);
		
		if($cellStyles !="0" && $cellStyles !=""){
			$stylesListPara = explode('_',$cellStyles);
			foreach ($stylesListPara as $val ){
				$stylesList_arr[]= $val;
			}
		}
		$wrapped_data['cellStyles'] = $cellStyles ? $stylesList_arr : array(
			'text-align:left', 'text-align:left', 'text-align:center', 'text-align:left', 'text-align:center', 'text-align:center',
			'text-align:center', 'text-align:center', 'text-align:center', 'text-align:center', 'text-align:center', 'text-align:center', 
			'text-align:center', 'text-align:left', 'text-align:left', 'text-align:left', 'text-align:left'
		);
		
		//manual pagination related code
		$wrapped_data['data']['dataset']['limit'] = $limit;
		$wrapped_data['data']['dataset']['offset'] = $offset;
		
		//If AIR_call_flag is true which means its an AIR related call/external call=========================
		//if($this->AIR_call_flag){
			// if the function call is from an external app then identify request method then
			// choose appropriate output mechanism.
			//if($this->debug) log_message('info',"index() invoked via AIR call: QUERY- STRING :".count($_POST)>0?serialize($_POST):serialize($_GET));
			//$wrapped_data['request_method'] = $this->AR_Utilities->request_method;
			//$this->load->view('AIR_output',$wrapped_data);
		//}else{
			// if the function call is from application itself then proceed with normal output.
			$this->load->view($file,$wrapped_data);
		//}//end if air call validator
		//End of AIR mechanism ==============================================================================
	}//end of index method
	
	
	/**
	 * Function  ad_display ()
	 * 
	 * 
	 * This function displays advertorial details of a job post. This function is accessed by routes
	 *  	
	 * @access 			public 
	 * @since 			
	 * @modified		Jun 6, 2016 by user
	 * @modification	
	 * @return 			void
	 */
	function ad_display(){
		$this->log_create->set_otherDetails(array('Mode'=>'Ad Display','Data'=>'QUERY- STRING:'.count($_POST)>0?serialize($_POST):serialize($_GET)));
		$this->log_create->init();
		
		$post_id = $this->input->get('post_id',true);
		$pid = $this->input->get('pid',true);
		$result = $this->job_definitions_model->get_data(
			array(
				'search'=>array(
					array('search_field'=>'id', 'search_text'=>$post_id, 'query_method'=>'equal'),
					array('search_field'=>'status', 'search_text'=>'active', 'query_method'=>'equal')
				),'limit'=>1, 'offset'=> 0, 'order_by'=>array('job_definitions.id'=>'Asc')
			)
		);
		if(!empty($result['result_set'][1])){
			$wrapper['result'] = $result['result_set'][1];
			
			//check and replace 'apply_now' button url
			$advertorial = $result['result_set'][1]['advertorial'];
			
			if(!strpos('job_applications.php?',$advertorial)){
				$doc = new DOMDocument();
				$doc->loadHTML($advertorial);
				$as = $doc->getElementsByTagName('a');
				
				foreach( $as as $a ){
					if(!empty($pid)){ $href= site_url("job_applications/apply_form?post_id=".$post_id."&pid=".$pid); }
					else{ $href= site_url("job_applications/apply_form?post_id=".$post_id); }
					$a->setAttribute("href", $href);
				}
				$advertorial = $doc->saveHTML();
				
				$result['result_set'][1]['advertorial'] = $advertorial;
				$wrapper['result'] = $result['result_set'][1];
			}
			$wrapper['msg'] = array();
		}
		else{
			$wrapper['msg'][] = array('type'=>"error",'msg'=>'Job vacancy not available!');
			$wrapper['result'] = array();
		}
		$this->load->view('job_ad',$wrapper);
	}//end of function
	
	
	function  limit_strings($str, $length,$para){
		if(strlen($str) <= $length){
			return $str;
		}else{
			$short_str = substr ($str,0,$length) . '<br>(<a href="#" onclick="view_more(\''.$para.'\')">View</a>)';
			return $short_str;
		}
	}//end of function
	
	
	public function view($para){
		$para = urldecode($para);
		$paras = explode('|||',$para);
		$id = $paras[0];
		$field = $paras[1];
		
		$searchobj_array = array();
		$search_obj= array('search_field' => 'id', 'search_text' => $id, 'query_method'=>'equal');	 
		array_push($searchobj_array, $search_obj);		 
		$result = $this->job_definitions_model->get_data(
			array(
				'search'=>$searchobj_array,
				'limit' => 1,
				'offset'=> 0,
				'order_by'=>array('job_definitions.id'=>'Asc')						
			)
		);
		
		$data['field_data'] = $result['result_set'][1][$field];
		$data['field_name'] = $result['metadata'][$field]['header'];
		
		$this->log_create->set_otherDetails(array('Mode'=>"view-$field",'Data'=>'QUERY- STRING:'.count($_POST)>0?serialize($_POST):serialize($_GET)));
		$this->log_create->init();
		
		$this->load->view('job_definitions_field_view',$data);
	}//end of function
	
	
	/**
	 * Function data_form
	 *  
	 * 
	 * function handaling form add,edit,delete and view features
	 * 
	 * @param  $data stirng values, key
	 * @param  $mode strign, forms type add, edit, delete, view
	 * @return	
	 * @access	
	 * @since	1.0
	 * 
	 */
	function data_form($mode='add',$data = null){
		$this->log_create->set_otherDetails(array('Mode'=>$mode?$mode:'-','Data'=>$_POST?serialize($_POST):($data!=''?$data:'-')));
		$this->log_create->init();
		
		$v_str = null;
		$data2save = array();
		$key2save = array();
		$message = array('msgText'=>'','msgType'=>'','focusField'=>'');
		
		//$staff_array = get_staff_array();
		$staff_array = staff_array();
		$manager_options = get_contents_with_session(STAFF_DROPDOWN.'?filterby=users.user_type_equal=4,staff.status_equal=1&optionsonly=true');	
		$worktype_options = get_contents_with_session(WORKTYPE_DROPDOWN.'?optionsonly=true');
		$jobprofile_options = get_contents_with_session(JOBPROFILE_DROPDOWN.'?optionsonly=true');
		
		if($mode != 'add'){
			$limit=0;
			$offset=0;
		
			$row=$this->job_definitions_model->get_data(array('search'=>array(array('search_field' => 'id', 'search_text' => $data,'query_method'=>'equal')),'limit' => $limit,'offset'=>$offset)) ;
			$w = $row['result_set'][1]; //should we validate if there is records?
			foreach ($w as $c=>$v){ $wrapper[$c] = $v; }
		}
		
		if($_POST){
			$postData = $_POST;
			
			foreach($postData as $c=>$v){
				$v_str = null;
				if($c!='mode' && $c!='formstatus'){					
					//some data will come as an array so concate the values with comma. Since table stores them as one line string
					// this was migrated from phpmyedit datastructure MRMR 11/4/2016
					if(is_array($v)){
						foreach($v as $it){
							if(!empty($it))
								$v_str .= $it.',';							
						}
						$v_str = rtrim($v_str,',');			
						$data2save[$c] = $v_str;
					}else{						
						$data2save[$c] = $v;
					}		
				}
				//for forms
				if(is_array($v)){
					foreach($v as $it){
						if(!empty($it))
							$v_str .= $it.',';
					}
					$v_str = rtrim($v_str,',');					
					$wrapper[$c] =  $v_str;
				}
				else{
					$wrapper[$c] = $v;
				}
			}//end foreach
			if($this->input->post('id') !=''){
				$key2save = array('id' =>$this->input->post('id'));
			}
		}	
		
		switch ($mode){
	
			case "add": //-----------------------------------------------------
				//Check duplicates
				echo "add form";
				if ($this->input->post('designation')) {
					if ($this->job_definitions_model->exists(array('designation' => $this->input->post('designation')))) {
						$message['msgText'] ='Sorry this job definition already exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='designation';
					}else{
						$msg = $this->job_definitions_model->save($data2save,$key2save);
						if ($msg) {
							$message['msgText'] ='<span style="color:#008000;">Job definition successfully created!</span>';
							$message['msgType'] ='success';
							$message['gridHandler'] ='updateAndClose';
						}else{
							$message['msgText'] =$msg;
							$message['msgType'] ='failure';
							$message['focusField'] ='designation';
						}
					}
				}
			break;
			case "edit":
				//Do validations if form submitted based on POST var
				echo "edit form";
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_definitions_model->exists(array('id' => $this->input->post('id')))) {
						$message['msgText'] ='Sorry this job definition does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='designation';
					}else{//Valid key
						//checking existance
						if ($this->job_definitions_model->exists(array('designation' => $this->input->post('designation'),'id !=' => $this->input->post('id')))){
							$message['msgText'] ='Sorry this job definition already exist!';
							$message['msgType'] ='failure';
							$message['focusField'] ='designation';
						
						}else{
						    $msg = $this->job_definitions_model->save($data2save,$key2save);
							if ($msg) {
								if($_POST['Status']=='Inactive'){
									$del_tms = get_contents_with_session(site_url()."/tms_post_controller/data_form/tms_delete/?job_id=".$_POST['id']);
								}
								$message['msgText'] ='<span style="color:#008000;">Job definition successfully updated!</span>';
								$message['msgType'] ='success';
								$message['gridHandler'] ='updateAndClose';
							}else{
								$message['msgText'] =$msg;
								$message['msgType'] ='failure';
								$message['focusField'] ='designation';
							}
						}
					}
					//end validation & save
				}
			break;
			case "delete":
				$id = $this->input->post('id');
				//Do validations if form submitted based on POST var
				if (!empty($id)) {
					//check for prime key existance
					if (!$this->job_definitions_model->exists(array('id' => $id))) {
					 $message['msgText'] ='Sorry this record does not exist!';
					 $message['msgType'] ='failure';
					 $message['focusField'] ='';
					}
				}
			break;
			case "view":

			break;
		}
		
		$wrapper['message'] = $message;
		$wrapper['mode'] = $mode;
		$wrapper['staff_array'] = $staff_array;
		$wrapper['manager_options'] = $manager_options;
		$wrapper['worktype_options'] = $worktype_options;
		$wrapper['jobprofile_options'] = $jobprofile_options;
		echo "end form";
		$this->load->view('job_definitions_form',$wrapper);
	}
	/**
	 * Function get_data_form
	 *
	 *
	 * function handaling form add,edit,delete and view features
	 *
	 * @param  $data stirng values, key
	 * @param  $mode strign, forms type add, edit, delete, view
	 * @return
	 * @access
	 * @since	1.0
	 *
	 */
	function get_data_form($mode='add',$data = null){
		$this->log_create->set_otherDetails(array('Mode'=>$mode?$mode:'-','Data'=>$_POST?serialize($_POST):($data!=''?$data:'-')));
		$this->log_create->init();
	
		$v_str = null;
		$data2save = array();
		$key2save = array();
		$message = array('msgText'=>'','msgType'=>'','focusField'=>'');
	
		//$staff_array = get_staff_array();
		$staff_array = staff_array();
		$manager_options = get_contents_with_session(STAFF_DROPDOWN.'?filterby=users.user_type_equal=4,staff.status_equal=1&optionsonly=true');
		$worktype_options = get_contents_with_session(WORKTYPE_DROPDOWN.'?optionsonly=true');
		$jobprofile_options = get_contents_with_session(JOBPROFILE_DROPDOWN.'?optionsonly=true');
	
		if($mode != 'add'){
			$limit=0;
			$offset=0;
	
			$row=$this->job_definitions_model->get_data(array('search'=>array(array('search_field' => 'id', 'search_text' => $data,'query_method'=>'equal')),'limit' => $limit,'offset'=>$offset)) ;
			$w = $row['result_set'][1]; //should we validate if there is records?
			foreach ($w as $c=>$v){ $wrapper[$c] = $v; }
		}
	
		if($_POST){
			$postData = $_POST;
				
			foreach($postData as $c=>$v){
				$v_str = null;
				if($c!='mode' && $c!='formstatus'){
					//some data will come as an array so concate the values with comma. Since table stores them as one line string
					// this was migrated from phpmyedit datastructure MRMR 11/4/2016
					if(is_array($v)){
						foreach($v as $it){
							if(!empty($it))
								$v_str .= $it.',';
						}
						$v_str = rtrim($v_str,',');
						$data2save[$c] = $v_str;
					}else{
						$data2save[$c] = $v;
					}
				}
				//for forms
				if(is_array($v)){
					foreach($v as $it){
						if(!empty($it))
							$v_str .= $it.',';
					}
					$v_str = rtrim($v_str,',');
					$wrapper[$c] =  $v_str;
				}
				else{
					$wrapper[$c] = $v;
				}
			}//end foreach
			if($this->input->post('id') !=''){
				$key2save = array('id' =>$this->input->post('id'));
			}
		}
	
		switch ($mode){
	
			case "add": //-----------------------------------------------------
				//Check duplicates
				//echo "add";
				if ($this->input->post('designation')) {
					if ($this->job_definitions_model->exists(array('designation' => $this->input->post('designation')))) {
						$message['msgText'] ='Sorry this job definition already exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='designation';
						echo "exist";
						
					}else{
						$msg = $this->job_definitions_model->save($data2save,$key2save);
						if ($msg) {
							
							$message['msgText'] ='<span style="color:#008000;">Job definition successfully created!</span>';
							$message['msgType'] ='success';
							$message['gridHandler'] ='updateAndClose';
							
								$this->load->library('email');
								
								$this->email->from('hrmadmin@kindersigns.org', 'HRm Admin');
								//$this->email->to('thilan.s@ekwa.com');
								$this->email->to('careers@ekwa.com');
								$this->email->cc('pda@ekwa.com');
								$this->email->bcc($this->user_email);
								
								$this->email->subject('Testing-New Job Definition');
								//$this->email->message('<b>Testing</b> the email class.');
								//$username=$this->$user_name;
								//echo $username;
								$users_name=$_SESSION["user_name"];
								$users_role=$_SESSION["user_type"];
								$this->email->message('New Job Definition pending for approve.Created By '.$users_name.'( '.$users_role. ') Please Refere HRM Pending Approve List For Futher Details.');
								$this->email->set_mailtype("html");
								
								if($this->email->send()){
									echo "successfully send";
								}
								else{
									echo "Email send Fail";
								}
							
							
							echo 'success';
						}else{
							$message['msgText'] =$msg;
							$message['msgType'] ='failure';
							$message['focusField'] ='designation';
							echo 'failure';
						}
					}
				}
				break;
			case "edit":
				//Do validations if form submitted based on POST var
				//echo "edit";
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_definitions_model->exists(array('id' => $this->input->post('id')))) {
						$message['msgText'] ='Sorry this job definition does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='designation';
					}else{//Valid key
						//checking existance
						///if ($this->job_definitions_model->exists(array('designation' => $this->input->post('designation'),'id !=' => $this->input->post('id')))){
						///	$message['msgText'] ='Sorry this job definition already exist!';
						///	$message['msgType'] ='failure';
						///	$message['focusField'] ='designation';
	
						//}
						///else{
							$msg = $this->job_definitions_model->save($data2save,$key2save);
							if ($msg) {
								//if($_POST['Status']=='Inactive'){
								//	$del_tms = get_contents_with_session(site_url()."/tms_post_controller/data_form/tms_delete/?job_id=".$_POST['id']);
								//}
								$message['msgText'] ='<span style="color:#008000;">Job definition successfully updated!</span>';
								$message['msgType'] ='success';
								$message['gridHandler'] ='updateAndClose';
								echo 'success';
							}else{
								$message['msgText'] =$msg;
								$message['msgType'] ='failure';
								$message['focusField'] ='designation';
								echo 'failure';
							}
						///}
					}
					//end validation & save
				}
				break;
			case "delete":
				$id = $this->input->post('id');
				//Do validations if form submitted based on POST var
				if (!empty($id)) {
					//check for prime key existance
					if (!$this->job_definitions_model->exists(array('id' => $id))) {
						$message['msgText'] ='Sorry this record does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='';
					}
				}
				break;
			case "view":
	
				break;
		}
		
		$wrapper['message'] = $message;
		$wrapper['mode'] = $mode;
		$wrapper['staff_array'] = $staff_array;
		$wrapper['manager_options'] = $manager_options;
		$wrapper['worktype_options'] = $worktype_options;
		$wrapper['jobprofile_options'] = $jobprofile_options;
		//echo "end";
		$this->load->view('job_definitions_form_add',$wrapper);
	}

	/**
	 * Function save_data_form
	 *
	 *
	 * function handaling form add,edit,delete and view features
	 *
	 * @param  $data stirng values, key
	 * @param  $mode strign, forms type add, edit, delete, view
	 * @return
	 * @access
	 * @since	1.0
	 *
	 */
	function save_data_form($mode='add',$data = null){
		$this->log_create->set_otherDetails(array('Mode'=>$mode?$mode:'-','Data'=>$_POST?serialize($_POST):($data!=''?$data:'-')));
		$this->log_create->init();
	
		$v_str = null;
		$data2save = array();
		$key2save = array();
		$message = array('msgText'=>'','msgType'=>'','focusField'=>'');
	
		//$staff_array = get_staff_array();
		$staff_array = staff_array();
		$manager_options = get_contents_with_session(STAFF_DROPDOWN.'?filterby=users.user_type_equal=4,staff.status_equal=1&optionsonly=true');
		$worktype_options = get_contents_with_session(WORKTYPE_DROPDOWN.'?optionsonly=true');
		$jobprofile_options = get_contents_with_session(JOBPROFILE_DROPDOWN.'?optionsonly=true');
	
		if($mode != 'add'){
			$limit=0;
			$offset=0;
	
			$row=$this->job_definitions_model->get_data(array('search'=>array(array('search_field' => 'id', 'search_text' => $data,'query_method'=>'equal')),'limit' => $limit,'offset'=>$offset)) ;
			$w = $row['result_set'][1]; //should we validate if there is records?
			foreach ($w as $c=>$v){ $wrapper[$c] = $v; }
		}
	
		if($_POST){
			$postData = $_POST;
	
			foreach($postData as $c=>$v){
				$v_str = null;
				if($c!='mode' && $c!='formstatus'){
					//some data will come as an array so concate the values with comma. Since table stores them as one line string
					// this was migrated from phpmyedit datastructure MRMR 11/4/2016
					if(is_array($v)){
						foreach($v as $it){
							if(!empty($it))
								$v_str .= $it.',';
						}
						$v_str = rtrim($v_str,',');
						$data2save[$c] = $v_str;
					}else{
						$data2save[$c] = $v;
					}
				}
				//for forms
				if(is_array($v)){
					foreach($v as $it){
						if(!empty($it))
							$v_str .= $it.',';
					}
					$v_str = rtrim($v_str,',');
					$wrapper[$c] =  $v_str;
				}
				else{
					$wrapper[$c] = $v;
				}
			}//end foreach
			if($this->input->post('id') !=''){
				$key2save = array('id' =>$this->input->post('id'));
			}
		}
	
		switch ($mode){
	
			case "add": //-----------------------------------------------------
				//Check duplicates
				//echo "add";
				if ($this->input->post('designation')) {
					if ($this->job_definitions_model->exists(array('designation' => $this->input->post('designation')))) {
						$message['msgText'] ='Sorry this job definition already exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='designation';
						echo "exist";
	
					}else{
						$msg = $this->job_definitions_model->save($data2save,$key2save);
						if ($msg) {
								
							$message['msgText'] ='<span style="color:#008000;">Job definition successfully created!</span>';
							$message['msgType'] ='success';
							$message['gridHandler'] ='updateAndClose';
								
							$this->load->library('email');
	
							$this->email->from('hrmadmin@kindersigns.org', 'HRm Admin');
							$this->email->to('thilan.s@ekwa.com');
							//$this->email->to('careers@ekwa.com');
							//$this->email->cc('pda@ekwa.com');
							$this->email->bcc($this->user_email);
	
							$this->email->subject('New Job Definition');
							//$this->email->message('<b>Testing</b> the email class.');
							//$username=$this->$user_name;
							//echo $username;
							$users_name=$_SESSION["user_name"];
							$users_role=$_SESSION["user_type"];
							$this->email->message('New Job Definition pending for approve.Created By '.$users_name.'( '.$users_role. ') Please Refere HRM Pending Approve List For Futher Details.');
							$this->email->set_mailtype("html");
	
							if($this->email->send()){
								echo "successfully send";
							}
							else{
								echo "Email send Fail";
							}
								
								
							echo 'success';
						}else{
							$message['msgText'] =$msg;
							$message['msgType'] ='failure';
							$message['focusField'] ='designation';
							echo 'failure';
						}
					}
				}
				break;
			case "edit":
				//Do validations if form submitted based on POST var
				//echo "edit";
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_definitions_model->exists(array('id' => $this->input->post('id')))) {
						$message['msgText'] ='Sorry this job definition does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='designation';
					}else{//Valid key
						//checking existance
						///if ($this->job_definitions_model->exists(array('designation' => $this->input->post('designation'),'id !=' => $this->input->post('id')))){
						///	$message['msgText'] ='Sorry this job definition already exist!';
						///	$message['msgType'] ='failure';
						///	$message['focusField'] ='designation';
	
						//}
						///else{
						$msg = $this->job_definitions_model->save($data2save,$key2save);
						if ($msg) {
							//if($_POST['Status']=='Inactive'){
							//	$del_tms = get_contents_with_session(site_url()."/tms_post_controller/data_form/tms_delete/?job_id=".$_POST['id']);
							//}
							$message['msgText'] ='<span style="color:#008000;">Job definition successfully updated!</span>';
							$message['msgType'] ='success';
							$message['gridHandler'] ='updateAndClose';
							echo 'success';
						}else{
							$message['msgText'] =$msg;
							$message['msgType'] ='failure';
							$message['focusField'] ='designation';
							echo 'failure';
						}
						///}
					}
					//end validation & save
				}
				break;
			case "delete":
				$id = $this->input->post('id');
				//Do validations if form submitted based on POST var
				if (!empty($id)) {
					//check for prime key existance
					if (!$this->job_definitions_model->exists(array('id' => $id))) {
						$message['msgText'] ='Sorry this record does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='';
					}
				}
				break;
			case "view":
	
				break;
		}
	
		/* $wrapper['message'] = $message;
		$wrapper['mode'] = $mode;
		$wrapper['staff_array'] = $staff_array;
		$wrapper['manager_options'] = $manager_options;
		$wrapper['worktype_options'] = $worktype_options;
		$wrapper['jobprofile_options'] = $jobprofile_options;
		//echo "end";
		$this->load->view('job_definitions_form_add',$wrapper); */
	}
	/**
	 * Function save()
	 * 
	 * 
	 * Data from View
	 * using $_REQUEST
	 * Data to model
	 * send data as a array
	 * two arrays. One is for data and one is for key.
	 * ex: data=array('field1'=>'value1','field2'=>'value2'.....);
	 *     key=array('staff_id'=>123,'project_id'=>534);
	 *     
	 * @param   action - add or edit
	 * @param   callback - callback fun name for field validation
	 * @return  bool true/false
	 * @access	
 	 * @since	2.0
 	 * 
	 */
  	function save($action,$callback = null){
  		$save_data = array();
  		$key = array();
  		$metadata = $this->job_definitions_model->getMetadata();
  		$metadata = explode(",",$metadata['PK']);
  		log_message('info','Save data :-'.serialize($_POST));
  		
  		foreach((count($_POST)>0?$_POST:$_GET) as $k => $v){
  			$end = substr(strrchr($k, "_"), 1);
  			if(in_array($k,$metadata) !== false) {
  				$key[$k] = $v;
  			}elseif($end=='skip') {
  				//nothing do with skip
  			}else {
  				$save_data[$k]=$v;
  			}
  		}
  		
  		$added=$this->job_definitions_model->save($save_data,$key);
  		$this->log_create->set_otherDetails(array('Mode'=>$action,'Data'=>serialize($save_data).", KEY: ".serialize($key)));
  		$this->log_create->init();
  		echo $added;
	    
	}//end of save method
	    
	    
	/**
	 * Function key_validate()
	 * 
	 *
	 * This is to validate the keys which are send based on the action param
	 * key = array('staff_id'=>123,'project_id'=>534,'worktype_id'=>342);
	 *
	 * @param 	$action , add / edit
	 * @param 	$key , primary $key can be composit or single
	 * @return	true on success or on valid key , on inexistance or invalid key error will be returned as an array
	 * 				ex: array('primary_key'=>'Doesnt exists','staff_id'=>'Doesnt exists')
	 * @access	
	 * @since	2.0
	 */
	function key_validate($action,$key) {
		//make overall validation true at the begining
	    $overall_valid=true;
	    $error_info=array();
	    
	    /*check for the primary key or composite key exists. Send key array to check.*/
	    $key_exist=$this->job_definitions_model->exists($key);
		
	    if($key_exist) {
	    	if($action=='add') {
	    		//if the primary key exists this can not add. so validation fails and add information
	    		//to error info array.
	    		$overall_valid=false;
	    		$error_info['primary_key']='Record Already exists';
	    	}
	    	if($action=='edit') {
	    		//in edit function the primary key should be there.
	    		//to error info array.
	    		$overall_valid=true;
	    	}
	    }
	    else {
	    	if($action=='add') {
	    		//if primary key not found it can be added
	    		$overall_valid=true;
	    	}
	    	if($action=='edit') {
	    		//if primary key not found it can not be edited
	    		$overall_valid=false;
	    		$error_info['primary_key']='Record Doesnt exists';
	    	}
	    }
	    if($overall_valid==true){ return true; }
	    else{ return $error_info; }
    }
 	
    
	/**
	 * Function delete()
	 * 
	 * 
	 * Data from View
	 * using $_REQUEST
	 * $_REQUEST['staff_id']=234
	 *
	 * @param $String, the key 
	 * 		Data to model
	 * 		send a array
	 * 		ex: $key = array('staff_id'=>123,'project_id'=>245,'worktype_id'=>933)
	 * @return 
	 * @access	
	 * @since	2.0
	 * 
	 */
	function delete($String){
        $delete=array();
		
		$delete['id'] = $String;
		$this->log_create->set_otherDetails(array('Mode'=>'delete','Data'=>serialize($delete)));
		$this->log_create->init();       		
		
		$feedback = $this->job_definitions_model->delete($delete);
		if($feedback){
			get_contents_with_session(site_url()."/tms_post_controller/data_form/tms_delete/?job_id=$String");
		}
		return($feedback);
	}
 	
	
	/**
	 * Function loadForm()
	 * 
	 * 
	 * load the form for creation / edit
	 * 
	 * @param $editable, key, mode info
	 * @param $file , name of the view file
	 * @return 
     * @access	
     * @since	2.0
     * 
	 */ 
  	function loadForm($editable=null,$file='job_definitions_form') {
  		$data['editable'] = $editable;
  		$this->load->view($file,$data);
  	} 
	
  	
	 /**
	  * Function loadWB()
	  * 
	  * 
	  * function initiates the workbech
	  *
	  * @param 	$file , name of the view file
	  * @return loads the work bench
      * @access	
      * @since	2.0
      * 
	  */
 	function loadWB($file='job_definitions_wb',$wbmanagerid=0,$wbuserid=0,$wbuserrole=''){
 		//$data ='';
 		$data['wbmanager_id'] = $wbmanagerid;
 		$data['wbuserid'] = $wbuserid;
 		$data['wbuserrole'] = $wbuserrole;	
 		
  		$this->load->view($file,$data);
  		$this->user_id=$wbuserid;
  		$this->user_type=$wbuserrole;
  		
  		$_SESSION["user_id"]=$wbuserid;
  		///$_SESSION["user_name"]="Thilan";
  		$user_type=$wbuserrole;
  		$user_type='Manager';
  		$_SESSION['user_type']=$user_type;
  		$staff_array=staff_array();
  		foreach($staff_array as $staff){
  			$id = $staff['staff_id'];
  			if($id ==$wbuserid){
  				$full_name = $staff['full_name'];
  				$office_email =$staff['office_email'];
  				//echo $full_name ;
  				$_SESSION["user_name"]=$full_name;
  				$_SESSION["office_email"]=$office_email;
  				//echo "email  ".$_SESSION["office_email"];
  			}
  		}
  		
  		//echo $_SESSION['user_type']." -type-";
  		//echo " - wbuserrole -".$wbuserrole;
  		//echo " -tyyy -".$user_type;
  		//echo "wbuserid_ses- ".$_SESSION["user_id"];
  	}
	

  	/**
  	 * Function loadWB()
  	 *
  	 *
  	 * function initiates the workbech
  	 *
  	 * @param 	$file , name of the view file
  	 * @return loads the work bench
  	 * @access
  	 * @since	2.0
  	 *
  	 */
  /* 	function loadWB($file='job_definitions_wb'){
  		$data ='';
  		$this->load->view($file,$data);
  	} */
	    /**
 		 * Function createDropdown()
 		 *
 		 * 
 		 * Function overview :-
 		 * createDropdown is the component function. 
 		 * Its main functionality is to produce a dropdown with pre populated table data
 		 *
 		 * Parameter list :-
 		 *
 		 *   $data['displayClm']     => 'field1'  - preselection of column to be displayed         //sachini
 		 *   $data['selectByValue']  => null      - preselection of list items by value
 		 *   $data['selectBYText']   => null      - preselection of list items by Text
 		 *   $data['filterBy']       => null      - filter data set by a field or list
 		 *   $data['outFormat']      => 'html'    - Format of the output like HTML,XML Etc
 		 *   $data['isMultiple']     => false     - is the drop down with multi select capable
 		 *   $data['sort']           => 'asc'     - sort list text Ascending or Descending
 		 *   $data['optionsOnly']    => false     - Specify the controller that output only <options> values
 		 *   $data['groupBy']        => null      - Display the dropdown grouped according to the specified column        //sachini
 		 *   $data['nameTag']        => 'field2'  - Name and Id values of the select tag                                 //sachini
 		 *
 		 *
 		 *    Usage :-
 		 *
 		 *    1) Format for internal functional call by passing data array
 		 *
 		 *    $data = array('selectByValue' => null,
 		 *					'selectBYText' => null,
 		 *					'outFormat' => 'html' ,
 		 *					'isMultiple' => false,
 		 *					'sort' => 'asc',
 		 *					'optionsOnly' => false,
 		 *					'filterBy' => array(
 		 *									'search_field' => 'T.status',
 		 *									'search_text' => '0',
 		 *									'query_method'=>'equal',
 		 *									'order_by' => 'asc'
 		 *									)
 		 *						)
 		 *
 		 *
 		 *    2) Format of external call by URL
 		 *    		http://.../index.php/Job_definitions/createDropdown/?sbv=null&sbt=null&format=html&multiple=false&sort=asc&filterby=status_equal=1
 		 *
 		 *    1. For normal listing:
 		 *    http://.../index.php/Job_definitions/createDropdown
 		 *
 		 *    2. For listing with multiple selection
 		 *    http://.../index.php/Job_definitions/createDropdown/?multiple=true
 		 *
 		 *    3. For listing with pre selection (select by value) for single selection drop down
 		 *    http://.../index.php/Job_definitions/createDropdown/?sbv=123
 		 *
 		 *    4. For listing with pre selection for multiple (select by value)
 		 *    http://.../index.php/Job_definitions/createDropdown/?sbv=123,321,345&multiple=true
 		 *
 		 *    5. For listing with pre selection of select by text for single selection dropdown
 		 *    http://.../index.php/Job_definitions/createDropdown/?sbt=test string&multiple=true
 		 *
 		 *    6. For xml(DHTMLX compatible) dropdown
 		 *    http://.../index.php/Job_definitions/createDropdown/?format=xml
 		 *
 		 *    7. groupBy
 		 *    http://...../Job_definitions/createDropdown/?groupby=users.user_type
 		 *
 		 *	  8. groupCode
 		 *	  http://..../Job_definitions/createDropdown/?groupby=users.user_type&groupcodes=1=Staff,2=Admin,4=Manager
 		 *
 		 *    Description of parameter list,
 		 *    sbv - selectByValue  => null
 		 *    sbt - selectBYText   => null
 		 *    format - outFormat   => 'html'
 		 *    multiple - isMultiple=> false
 		 *    sort - sort          => 'asc'
 		 *    filterby - filterBy  => null
 		 *    optionsOnly - options only listing
 		 *
 		 *    groupBy - column to group, should be specified with the table name ex: job_definitions.staff_id
 		 *	  groupcodes - coma seperated values to display as group lable
 		 *
		 * @param $data , data array
		 * @access public
		 * @return returns the table dropdown
		 * @since 1.0
		 * 
 		 */
	public function createDropdown($data = false){
	  	$dataset = null;
	  	$selectByValue = null;
	  	$selectBYText = null;
	  	$outFormat = 'html' ;
	  	$isMultiple = null;
	  	$sort = null;
	    $sort_array = array('job_definitions.id' => 'ASC');
	  	$filterBy = null;
	   	$searchobj_array = null;
	   	$optionsOnly = false;
	   	$label = null;
	   	$displayClm = 'job_definitions.designation';
	   	$groupBy = null;   
	   	$groupcodes = null;
	   	$nameTag = 'id'; 
	  	
	  	/**
	  	 *	first check whether the call is internal(ie:internal function call) or external(ie:url call)
	  	 *	to do this we can check $data variable.if this variable is an array it means its an internal call
	  	 *	if $data is 'false' it means its an external call.
	  	 */	
	  	if(is_array($data)){
	  		/** 
	  		 * this is an internal call. so construct the search obj with passed array parameeters. 
	  		 * extract the data and pass on to the view
	  		 */
	  		$selectByValue = isset($data['selectByValue'])?$data['selectByValue']:null;
	  		$selectBYText = isset($data['selectBYText'])?$data['selectBYText']:null;
	  		$outFormat = isset($data['outFormat'])?$data['outFormat']:null;
	  		$isMultiple = isset($data['isMultiple'])?$data['isMultiple']:false;
	  		$sort = isset($data['sort'])?$data['sort']:'job_definitions.id=ASC';
	  		$filterBy = isset($data['filterBy'])?$data['filterBy']:null;
	  		$optionsOnly = isset($data['optionsOnly'])?$data['optionsOnly']:false;
	  		
	  		$label = isset($data['label'])?$data['label']:'id';
	  		$displayClm = isset($data['display'])?$data['display']:$displayClm;
	  		$groupBy = isset($data['groupBy'])?$data['groupBy']:null;    
	  		$nameTag = isset($data['nameTag'])?$data['nameTag']:'id';    
	  		$groupcodes = isset($data['groupcodes'])?$data['groupcodes']:null;
	  	}
	  	else{
	  		/** 
	  		 * this is an external url call. So process $_GET or $_POST parameeter values and using
	  		 * these values construct search obj and fetch data for combo box
	  		 */
	  		if(count($_POST)>0 || count($_GET)>0){
	        	$myParams = count($_POST)>0? $_POST:$_GET;
	  
	  			$selectByValue = isset($myParams['sbv'])? $myParams['sbv']:null ;		
	  			$selectByValue = (!empty($selectByValue))?$selectByValue:null; // set default values if not supplied.
	  			 		
	  			$selectBYText = isset($myParams['sbt'])?$myParams['sbt']:null;
	  			$selectBYText = (!empty($selectBYText))?$selectBYText:null;
	  			
	  			$outFormat = isset($myParams['format'])?$myParams['format']:null;
	  			$outFormat = ($outFormat != 'html' && !empty($outFormat))?$outFormat:'html';
	  			
	  			$isMultiple = isset($myParams['multiple'])?$myParams['multiple']:null;
	  			$isMultiple = ($isMultiple == 'true')?true:false;
	  			
	  			$sort = isset($myParams['sort'])?$myParams['sort']:'job_definitions.id=ASC';
	  			
	  			$filterBy_string = isset($myParams['filterby'])? $myParams['filterby']:null;
	  			$filterBy_string = (!empty($filterBy_string))?$filterBy_string:null;
	  			
	  			$optionsOnly = isset($myParams['optionsonly'])? $myParams['optionsonly']:false;
	  			$optionsOnly = ($optionsOnly == 'true')? true:false;
	  
	  			$label = isset($myParams['label'])?$myParams['label']:null;
	  			$label = (!empty($label))?$label:null;
	  			
	  			$displayClm = isset($myParams['display'])? $myParams['display']:$displayClm;
	  			$displayClm = (!empty($displayClm))?$displayClm:'description';
	  			
	  			$groupBy = isset($myParams['groupby'])?$myParams['groupby']:null;    
	  			$groupBy = (!empty($groupBy))?$groupBy:null;                         
	  			
	  			$groupcodes = isset($myParams['groupcodes'])?$myParams['groupcodes']:null;
	  			
	  			/**
	  			 *	first check whether the request includes grouping
	  			 *	to do this we can check $groupBy variable.if this variable is null then it is ungrouped dropdown
	  			 *	if $groupBy is 'field1' it means its a request for grouped dropdown.
	  			 */
	  			if($groupBy){
	  				/**
	  				 * this is a grouped dropdown request
	  				 * set the $sort_array first sorted according to $groupBy column and then to $displayClm
	  				 */
	  				$sort_array = array($groupBy => 'ASC',$displayClm => 'ASC' );
	  				if (!empty($groupcodes)){
	  					$sortPara = explode(',',$groupcodes);
	  					foreach ($sortPara as $val ){
	  						$split =  explode('=',$val);
	  						$group[$split[0]]= $split[1];
	  					}
	  				}
	  			}else{
	  				/**
	  				 * this is not a grouped dropdown request
	  				 */
	  				$sort = isset($myParams['sort'])?$myParams['sort']:"$displayClm=ASC";
	  			}
	  			//end of sort allocation condition
	  			
	  			$nameTag = isset($myParams['nametag'])?$myParams['nametag']:$nameTag;   
	  			$nameTag = (!empty($nameTag))?$nameTag:'id';                       
	  			
	  			if(!empty($filterBy_string)){        
	  				$fieldPara = explode(',',$filterBy_string);
	          		foreach ($fieldPara as $val){
	             		$split =  explode('=',$val);
	             		$filterBy[$split[0]]= $split[1];
	          		}
	  			}
	  			else{
	  				$filterBy = null;
	  			}
	        	if (!empty($sort)){
	          		$sortPara = explode(',',$sort);
	          		foreach ($sortPara as $val){
	             		$split =  explode('=',$val);
	             		$sort_array[$split[0]]= $split[1];
	          		}
	        	}
	  		}
	  	}//end of param check and config
	  	// Construct search object if present
	  	 
	  	If ($filterBy){
	  		$searchobj_array = array();
	  		
	  		foreach($filterBy as $key => $val){
	  			$search_text = $val; //search text
	  			$query_method = substr(strrchr($key, "_"), 1);
	  			$pos = strrpos($key, '_');
	  			$field = substr($key, 0, $pos);
	  			$search_obj = array(
  					'search_field' => $field,
  					'search_text'  => $search_text,
  					'query_method' => $query_method
	  			);
	  			array_push($searchobj_array, $search_obj);
	  		}	
	  	}//end if
	  	
	  	//Construct selection list. (Fixed)
	    $selection = 'job_definitions.id,job_definitions.designation,job_definitions.advertorial,job_definitions.offer_template,job_definitions.rules_template,job_definitions.trade_test,job_definitions.work_type,job_definitions.accountability,job_definitions.job_profile,job_definitions.probation_period,job_definitions.probation_rate,job_definitions.confirmed_rate,job_definitions.currency,job_definitions.manager_id,job_definitions.hire_lead_time,job_definitions.Status,job_definitions.min_work_hrs,job_definitions.max_work_hrs,job_definitions.Remarks,job_definitions.new_app_alert,job_definitions.test_alert,job_definitions.intviw_alert,job_definitions.gen_alert,job_definitions.intview_guide';
	    
	    // Fetch data from model
	  	$dataset = $this->job_definitions_model->get_data(array(
  			'search' => $searchobj_array,
  	  		'limit' => 0,
  	  		'offset'=>0,
  			'selection' => $selection,
       		'order_by' => $sort_array
	  	));  
	  	
	  	// Construct data structure for view
	  	$wrapped_data['data']['dataset'] = $dataset;	
	    $wrapped_data['selectByValue'] = $selectByValue;
	  	$wrapped_data['selectByText'] = $selectBYText;
	  	$wrapped_data['outFormat'] = $outFormat;
	  	$wrapped_data['isMultiple'] = $isMultiple;
	  	$wrapped_data['required'] = true;
		$wrapped_data['label'] = $label;
		
		$displayClm =  explode('.',$displayClm);
		$wrapped_data['display'] = $displayClm[1];
		$wrapped_data['nameTag'] = $nameTag;
	  	
	  	if($optionsOnly !=""){
	  		$wrapped_data['optionsOnly'] = $optionsOnly;
	  	}
	  	
	  	if($groupBy != ""){
	  		$gb_arrya=explode(",",$groupBy);
	  		for($x=0;$x<count($gb_arrya); $x++){
	  			$gb = explode(".",$gb_arrya[$x]);
	  			$wrapped_data['groupBy'] = $gb[1];
	  		}    
	  	}
	  	   
	  	if(!empty($group)){
	  		$wrapped_data['codename'] = $group;
	  	}
	  	
	  	//If AIR_call_flag is true which means its an AIR related call/external call=========================
	  	//if($this->AIR_call_flag){
	  		 
	  		// if the function call is from an external app then identify request method then
	  		// choose appropriate output mechanism.
	  		 
	  		//if($this->debug) log_message('info',"createDropdown invoked via AIR call: QUERY- STRING :".count($_POST)>0?serialize($_POST):serialize($_GET));	  			
	  		//perform the function codes and call view file with output.
	  		//if($this->AR_Utilities->request_method == 'get'){	  	
	  		//	$this->load->view('dropdown_template',$wrapped_data);	  	
	  		//}else if($this->AR_Utilities->request_method == 'post'){	  	
	  			//If request method is post then use appropriate view files to output as post
	  			//...	  	
	  		//}//end if method verifier	  	
	  	//}else{	  	
	  		// if the function call is from application itself then proceed with normal output.	  		
	  		// load view file with assigned data array
	  		$this->load->view('dropdown_template',$wrapped_data);	  		
	  	//}//end if air call validator	  	
	  	//End of AIR mechanism ==============================================================================	  	
	  		  	
    }// End of Function createDropdown
    
    function sendmail(){
    	$this->load->library('email');
    		
    	$this->email->from('thilan.s@ekwa.com', 'Thilan Jauayasinghe');
    	$this->email->to('thilan.s@ekwa.com');
    	//$this->email->cc('thilan.s@ekwa.com');
    	//$this->email->bcc('them@their-example.com');
    		
    	$this->email->subject('Email Test1');
    	$this->email->message('<b>Testing</b> the email class.');

 	    $this->email->set_mailtype("html");
 	    $users_name=$_SESSION["user_name"];
 	    echo $users_name;
    	if($this->email->send()){
    		echo "successfully send";
    	}
    	else{
    		echo "Email send Fail";
    	}
    }
    
    
    /**
     * Function get_data()
     *
     *
     * Multiline detail description of the file goes here. you may
     * give any type of details here such as usage and examples
     *
     * @param		$definition_id string
     * @param		$field_name string
     * @return		void
     * @access		public
     * @since		3.0
     */
    function get_data($definition_id='0', $field_name='designation'){
    	$result = $this->job_definitions_model->get_data(
    		array(
    			'search'=>array(array('search_field'=>'id', 'search_text'=>$definition_id, 'query_method'=>'equal')),
    			'limit'=>1, 'offset'=> 0, 'order_by'=>array('job_definitions.id'=>'Asc')
    		)
    	);
    	echo "<pre>";print_r($result['result_set'][1]);echo"</pre>";
    	echo $result['result_set'][1][$field_name];
    }
}//-------- END CLASS -------------------------------------------------------
?>