<?php
/**
 * Single line Summary of the script file
 *
 *
 * @package			HRM\controller\dashboard
 * @version			3.0
 * @since			3.0 
 * @copyright		2017 - 2017, BizyCorp Internal Systems Development
 * @license			private, All rights reserved
 * @author			Nuwan Wickramarathne
 * 
 */
 if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/**
 * Single line Summary of the script file
 *
 *
 * Multiline detail description of the file goes here. you may 
 * give any type of details here such as usage and examples
 *
 * @package			HRM\controller\dashboard
 * @version			3.0
 * @since			3.0
 * @copyright		2017 - 2017, BizyCorp Internal Systems Development
 * @license			private, All rights reserved
 * @author			Nuwan Wickramarathne
 * @uses				
 * @see				
 * @created			Mar 17, 2017 by Nuwan Wickramarathne
 * @modified		Mar 17, 2017 by Nuwan Wickramarathne
 * @modification	
 * 
 */
 
class Dashboard extends CI_Controller{
	/**
	 * Function __construct
	 * 
	 *
	 * The constructor function
	 * 
	 * @param	None
	 * @return	void
	 * @access	
	 * @since	3.0
	 */
    function __construct(){
    	parent::__construct();
    	if($_SESSION){
    		$this->user_name=$_SESSION["user_name"];
    		$this->user_type=$_SESSION["user_type"];
    	}else{
    		$this->user_name='';
    		$this->user_type='';
    	}
    	$this->log_create = new log_object();
    	$this->log_create->set_disable($this->config->item('log_status'));
    	$this->log_create->set_userDetails($this->user_name, $this->user_type);
		
    	$this->load->model('job_applications_model');
    	$this->load->model('interview_schedules_model');
    	$this->load->model('job_definitions_model');
    }//end of construct__
	
	
     /**
      * Function index
      *
      *
      * Multiline detail description of the file goes here. you may 
      * give any type of details here such as usage and examples
      *
      * @param		None
      * @return		void
      * @access		public
      * @since		
      */
	function index(){
		$this->log_create->set_otherDetails(array('Mode'=>'view','Data'=>'QUERY- STRING:'.count($_POST)>0?serialize($_POST):serialize($_GET)));
		$this->log_create->init();
		
		$wrapped_data['totalapplications']	= $this->job_applications_model->gettotalrecordcount();
		$wrapped_data['new_apps']		= $this->job_applications_model->exists(array('status'=>"NEW"));
		$wrapped_data['shortlisted']	= $this->job_applications_model->exists(array('status'=>"SHORTLISTED"));
		$wrapped_data['interview_end']	= $this->job_applications_model->exists(array('status'=>"SEND LETTER"));
		$wrapped_data['hire_pending']	= $this->job_applications_model->exists(array('status'=>"REVIEW LETTER"));
		$wrapped_data['job_definition_pending']	= $this->job_definitions_model->exists(array('pdaapprove'=>"Pending"));
		$wrapped_data['job_definition_approved']	= $this->job_definitions_model->exists(array('pdaapprove'=>"Approved"));
		$wrapped_data['job_definition_reject']	= $this->job_definitions_model->exists(array('pdaapprove'=>"Reject"));
		
		
		
		$date = isset($_GET['date'])?$_GET['date']:date("Y-m-d");
		$interview = $this->interview_schedules_model->get_data(array(
			'search'=>array(
				array('search_field'=>'interview_schedules.scheduled_datetime', 'search_text'=>$date, 'query_method'=>'like'),
				array('search_field'=>'interview_schedules.status', 'search_text'=>"pending", 'query_method'=>'equal'),
				array('search_field'=>'interview_schedules.type', 'search_text'=>"interview", 'query_method'=>'equal')
			), 'limit'=>0, 'offset'=>0, 'order_by'=>array('interview_schedules.IS_id'=>'Desc')
		));
		$wrapped_data['interview'] = $interview['result_set'];
		
		$interview_test = $this->interview_schedules_model->get_data(array(
			'search'=>array(
				array('search_field'=>'interview_schedules.scheduled_datetime', 'search_text'=>$date, 'query_method'=>'like'),
				array('search_field'=>'interview_schedules.status', 'search_text'=>"pending", 'query_method'=>'equal'),
				array('search_field'=>'interview_schedules.type', 'search_text'=>"test", 'query_method'=>'equal')
			), 'limit'=>0, 'offset'=>0, 'order_by'=>array('interview_schedules.IS_id'=>'Desc')
		));
		$wrapped_data['test'] = $interview_test['result_set'];
		
		$this->load->view('dashboard_view',$wrapped_data);
	}//end of index method
	
	
}//-------- END CLASS -------------------------------------------------------
?>