<?php
/**
 * This controller facilitates the access of table job_applications
 *
 * @package    HRM\controller\job_applications
 * @version    1.0
 * @copyright  2016, BizyCorp Internal Systems Development
 * @license    private, All rights reserved
 * @author     CIGen (Automated CI Code Generator)
 */

if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * This file contains CI controller for CI Code Generation
 * 
 * 
 * This class contains the following functions
 *
 *  1) function index() , can be used to retrieve data from the table with filteration
 *	2) function save() , can be used to add / update data
 *	3) function key_validate() , used to validate the primary key of the table
 *	4) function delete() , used to delete a record
 *	5) function loadForm(), used to load the forms
 *	6) public function createDropdown(), generates the dropdown
 *	7) function loadWB(), initiates the workbench
 *
 * @package      HRM\controller\job_applications
 * @version		 1.0
 * @uses			
 * @see				
 * @copyright	 2016, BizyCorp Internal Systems Development
 * @license		 private, All rights reserved
 * @author		 CIGen (Automated CI Code Generator)
 * @created    	Mar 25, 2016
 * @modified   	Mar 25, 2016
 * @modification 
 */
class Job_applications extends CI_Controller{
	
	/**
	 * AIR related vars
	 * Default request method
	 * @var $request_method
	 */
	private $request_method = 'get'; 

	/**
	 * AIR related vars
	 * This is reffering to the token which is received from calling app.
	 * @var $received_token
	 */
	private $received_token = null;  
	
	/**
	 * AIR related vars
	 * Default This is reffering to the token whic is generated and obtained from AIR directly
	 * @var $token
	 */
	private $token 			= null; 

	/**
	 * AIR related vars
	 * $AIR_call_flag
	 * @var $AIR_call_flag
	 */
	private $AIR_call_flag 	= false;
	
	/**
	 * AIR related vars
	 * debug
	 * @var $debug
	 */
	private $debug 			= true;  
	
	/**
	 * AIR related vars
	 * AR_Utilities
	 * @var $AR_Utilities
	 */
	private $AR_Utilities 	= null;

	/**
	 * Common vars
	 * User Name
	 * @var $user_name
	 */
	private $user_name='';	
	
	/**
	 * Common vars
	 * User Type
	 * @var $user_type
	 */
	private $user_type='';
	
	/**
	 * Common vars
	 * Log Object instance
	 * @var $log_create
	 */
	private $log_create='';
	
	
	/**
	 * Function __construct
	 * 
	 *
	 * The constructor function
	 * 
	 * @param	None
	 * @return	void
	 * @access	
	 * @since	1.0
	 */
    function __construct(){
    	parent::__construct();
    	if($_SESSION){
    		$this->user_name=$_SESSION["user_name"];
    		$this->user_type=$_SESSION["user_type"];
    	}else{
    		$this->user_name='';
    		$this->user_type='';
    	}
    	
    	$this->log_create = new log_object();
    	$this->log_create->set_disable($this->config->item('log_status'));
    	$this->log_create->set_userDetails($this->user_name, $this->user_type);
    	
    	/* Init AIR Lib===========================================================
         * 
         * check http request method. If its 'get' then output/error messasges can be echoed directly.
         * if http request method is 'post' then AR_Utilities class header method should be implemented
         * 
         */
        
    	if(isset($_GET['token']) && !empty($_GET['token'])){
    		$this->received_token = $_GET['token'];
    		$this->request_method = 'get';
    	}else if(isset($_POST['token']) && !empty($_POST['token'])){
    		$this->received_token = $_POST['token'];
    		$this->request_method = 'post';
    	}else if(isset($_GET['token']) && empty($_GET['token'])){
    		$this->received_token = null;
    		$this->request_method = 'get';
    		//if the request is get type then echo the error code and err msg directly
    		echo "Error : 511 Token was not given!<br>";
    		exit;
    	}else if(isset($_POST['token']) && empty($_POST['token'])){
    		$this->received_token = null;
    		$this->request_method = 'post';
    		//if the request is post type then use header output
    		$this->header_output(511,'Token was not given!!');
    		exit;
    	}
    	if(!empty($this->received_token)){
    		// Load AR_Utilities library only if an external call is made on this controller.
    		//$this->load->library('AR_Utilities');
    		//$this->AR_Utilities = new AR_Utilities("called_app",$this->received_token,$this->request_method);
    		//if($this->AR_Utilities->validityStatus['validity'] == 'VALID'){
    		//	$this->AIR_call_flag = true;
    		//}
    	}//end if
    	//==================================================================================
    	$this->load->model('job_applications_model');
    	$this->load->model('Job_definitions_model');
    	$this->load->model('profiles_model');
    	$this->load->model('settings_model');
    	$this->load->model('Offer_letter_model');
    	$this->load->model('Academic_qualifications_model');
    	$this->load->model('Professional_qualifications_model');
    	$this->load->model('Work_experience_model');
    	$this->load->library('email');
    }//end of construct__
	
	
	/**
	 * Function set_external_session_vars()
	 * 
	 *
	 * This method is be executed for extra function definitions to be implemented when AIR token verification
	 * is done.
	 * This function is executed by AIR_Utilities class upon successfull token verification
	 *
	 * @param	None
	 * @return	void
	 * @access	public
	 * @since	1.0
	 */
	public function set_external_session_vars(){
		// You can specify custome session variables soon after AIR call and token is verified.
		// By default after token verification, necessessary UAACS session vars get initiated inside AR_Utilities class. 
		// This method can be used to initiate additional session vars if needed
		// example usage
		// $_SESSION['Test_Session_1'] = 'This is a test session';
	}//end of set_txternal_session_vars();
	
		
	function array_insert (&$array, $position, $insert_array) {
		$first_array = array_splice ($array, 0, $position);
		$array = array_merge ($first_array, $insert_array, $array);
	}
	
	
		/**
		 * Function index()
		 * 
		 *
		 * @param $search, Boolean value whether search is enable or not
		 * @param $limit, Limit of record set
		 * @param $offset, Offset of record set
		 * @param $file , view file
		 * @param $format , format of the out put
		 * @param $collist, to pass the column filter to the view columns are sent as
		 *        col01:col02:...:coln and is pased to view as an array of col names
		 *        (Added by WCD on 31/7/13)
		 * @param $widths to pass the column widths to the view, widths are sent as col1=10:col2=25.... to the controller
		 * 		  controller will pass the width as array to the view
		 * 		  array('col1'=>10,'col2'=>25)
		 * @param $visibilityList, pass the visibility list to the view, list should be sent col1=true:col2=false ... to the controller 
		 * 		  and the contorller will process the param and construct an array as 
		 *        array(col1=>true,col2=>true,col3=>false)) and pass it to the view
	     * @param $cellStyles, pass the cell styles list to the view, list should be sent text-align:center_text-align:center_text-align:left ... to the controller 
	     * 		  and the contorller will process the param and construct an array as 
	     *        array(text-align:center,text-align:center,text-align:center) and pass it to the view
	     *        
		 * Data from view :
		 * Use $_REQUEST
		 * Filed names are like :  filed_name_querymethod
		 *
		 *	Send to Model : Array of data
		 * ex: Array('search' => $searchobj_array,'limit' => $limit,'offset'=>$offset)
		 *
		 * Note : $searchobj_array is a array consist of set of objects.
		 * ex: $searchobj_array = array([0]=>array('search_filed'=>'name','search_text'=>'sara','query_method'=>'like'),[1]=>array('search_filed'=>'country','search_text'=>'srilanka','query_method'=>'equel'))
		 * @return  the data feed
		 * @access	public
	 	 * @since	1.0
		 */
      
	function index($search=FALSE,$limit=0,$offset=0,$file='data_feed_template',$format='',$collist='',$widths='',$visibilityList='',$cellStyles=''){	
		$this->log_create->set_otherDetails(array('Mode'=>'view','Data'=>'QUERY- STRING:'.count($_POST)>0?serialize($_POST):serialize($_GET)));
		$this->log_create->init();
		
		if($search==true){
			$searchobj_array = array();
			foreach((count($_POST)>0?$_POST:$_GET) as $key => $val){
				$search_text=$val; //search text
				$pos = strrpos($key, '_');
				$query_method = substr($key,$pos+1);
				$field= substr($key, 0, $pos);
				//var_dump($field);exit;
				
				//if filed has '.'
				$field = str_replace('/','.',$field);
				
				//log_message('info',"\$field :- $field");
				$search_obj= array('search_field' => $field, 'search_text' => $search_text,'query_method'=>$query_method);
				array_push($searchobj_array, $search_obj);
			}
			
			$data['dataset'] = $this->job_applications_model->get_data(
				array(
                	'search'=>$searchobj_array, 'limit' => $limit, 'offset'=>$offset,
                	'order_by'=>array('job_applications.id'=>'Desc')
				)
			);
		}
        else {
        	$data['dataset'] = $this->job_applications_model->get_data(
        		array(
        			'limit' => $limit, 'offset'=>$offset,
                   	'order_by'=>array('job_applications.id'=>'Desc')
        		)
        	);
        }
		
        $wrapped_data['data'] = $data;
        $wrapped_data['format'] = $format;
        $wrapped_data['searchOn'] = $search;
        $wrapped_data['collist'] = $collist ? explode(':',$collist) :array(         
            'designation', 'app_date', 'first_name', 'last_name', 'status', 'gender', 'country', 'email', 'land_phone', 'mobile_phone',
            'have_adsl', 'has_own_computer', 'has_other_job', 'stat_cng_date'
        );
        if($widths !="0" && $widths !=""){
        	$widthsPara = explode(':',$widths);
        	foreach ($widthsPara as $val )   {
        		$split =  explode('=',$val);
        		$widths_arr[$split[0]]= $split[1];
        	}
        }
        $wrapped_data['widths'] = $widths ? $widths_arr:array(
           	'designation'=>200, 'app_date'=>150, 'first_name'=>100, 'last_name'=>100, 'status'=>150, 'gender'=>100, 'country'=>100,
           	'email'=>150, 'land_phone'=>100, 'mobile_phone'=>100, 'have_adsl'=>100, 'has_own_computer'=>100,
           	'has_other_job'=>150, 'stat_cng_date'=>150
        );
        
        if($visibilityList !="0" && $visibilityList !=""){
           	$visibilityListPara = explode(':',$visibilityList);
           	foreach ($visibilityListPara as $val )   {
           		$split =  explode('=',$val);
           		$visibilityList_arr[$split[0]]= $split[1];
           	}
		}
		$wrapped_data['visibilityList'] = $visibilityList ? $visibilityList_arr : array(
   			'designation'=>true, 'app_date'=>true, 'first_name'=>true, 'last_name'=>true, 'status'=>true, 'gender'=>true, 'country'=>true,
   			'email'=>true, 'land_phone'=>true, 'mobile_phone'=>true, 'have_adsl'=>true, 'has_own_computer'=>true,
   			'has_other_job'=>true, 'stat_cng_date'=>true
    	);
		
		if($cellStyles !="0" && $cellStyles !=""){
			$stylesListPara = explode('_',$cellStyles);
			foreach ($stylesListPara as $val )   { 
				$stylesList_arr[]= $val;
			}
		}
		$wrapped_data['cellStyles'] = $cellStyles ? $stylesList_arr : array(
   			'text-align:left', 'text-align:center', 'text-align:left', 'text-align:left', 'text-align:center', 'text-align:center', 
			'text-align:center', 'text-align:left', 'text-align:left', 'text-align:left', 'text-align:left', 'text-align:center', 
			'text-align:center', 'text-align:center', 'text-align:center'
 		);
		
		//manual pagination related code
		$wrapped_data['data']['dataset']['limit'] = $limit;
		$wrapped_data['data']['dataset']['offset'] = $offset;
		
		//If AIR_call_flag is true which means its an AIR related call/external call=========================
		//if($this->AIR_call_flag){
			// if the function call is from an external app then identify request method then
			// choose appropriate output mechanism.
			//if($this->debug) log_message('info',"index() invoked via AIR call: QUERY- STRING :".count($_POST)>0?serialize($_POST):serialize($_GET));
			//$wrapped_data['request_method'] = $this->AR_Utilities->request_method;
			//$this->load->view('AIR_output',$wrapped_data);
		//}
		//else{
			// if the function call is from application itself then proceed with normal output.
			$this->load->view($file,$wrapped_data);
		//}//end if air call validator
		//End of AIR mechanism ============================================================================== 
	}//end of index method
	
	
	/**
	 * Function data_form
	 *  
	 * 
	 * function handaling form add,edit,delete and view features
	 * 
	 * @param  $data stirng values, key
	 * @param  $mode strign, forms type add, edit, delete, view
	 * @return	
	 * @access	
	 * @since	1.0
	 */
	function data_form($mode='add',$data = null){
		$this->log_create->set_otherDetails(array('Mode'=>$mode?$mode:'-','Data'=>$_POST?serialize($this->input->post()):($data!=''?$data:'-')));
		$this->log_create->init();
		
		$data2save = array();
		$key2save = array();
		$message = array('msgText'=>'','msgType'=>'','focusField'=>'');
		
		if($mode != 'add'){
			$limit = 0;
			$offset = 0;
			
			$row = $this->job_applications_model->get_data(
				array(
					'search'=>array(array('search_field' => 'job_applications.id', 'search_text' => $data, 'query_method'=>'equal')),
					'limit' => $limit,
					'offset'=>$offset
				)
			);
			$w = $row['result_set'][1]; //should we validate if there is records?
			foreach ($w as $c=>$v){ $wrapper[$c] = $v; }
		}
		
		if($_POST){
			//$postData = $this->input->post();
			$postData = $_POST;
			
			foreach($postData as $c=>$v){
				if($c!='mode' && $c!='formstatus'){
					$data2save[$c] = $v;
				}
				$wrapper[$c] = $v;
			}
			if($this->input->post('id') !=''){
				$key2save = array('id' =>$this->input->post('id'));
			}
		}
		
		switch ($mode){
			case "add": //-----------------------------------------------------
				//Check duplicates
				if ($this->input->post('first_name')) {
					if ($this->job_applications_model->exists(array('first_name' => $this->input->post('first_name')))) {
						$message['msgText'] ='Sorry this record already exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='first_name';
					}
					else{
						$msg = $this->job_applications_model->save($data2save,$key2save);
						if ($msg) {
							$message['msgText'] ='<span style="color:#008000;">Record successfully created!</span>';
							$message['msgType'] ='success';
							$message['gridHandler'] ='updateAndClose';
						}
						else{
							$message['msgText'] =$msg;
							$message['msgType'] ='failure';
							$message['focusField'] ='first_name';
						}
					}
				}
			break;
			case "edit":
				//Do validations if form submitted based on POST var
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_applications_model->exists(array('id' => $this->input->post('id')))) {
						echo "not exist";
						print_r($data2save);
						$message['msgText'] ='Sorry this record does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='first_name';
					}
					else{//Valid key
						    $msg = $this->job_applications_model->save($data2save,$key2save);
							if ($msg) {
								$message['msgText'] ='<span style="color:#008000;">Record successfully updated!</span>';
								$message['msgType'] ='success';
								$message['gridHandler'] ='updateAndClose';
								echo 'success';
							}else{
								$message['msgText'] =$msg;
								$message['msgType'] ='failure';
								$message['focusField'] ='first_name';
								echo 'failure';
							}
				 	}
				 	//end validation & save
				}
			break;
			case "delete":
				//Do validations if form submitted based on POST var
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_applications_model->exists(array('id' => $this->input->post('id')))) {
						$message['msgText'] ='Sorry this record does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='';
					}
				}
			break;
			case "view":
				$wrapper['job_definition_options'] = get_contents_with_session(site_url('/job_definitions/createDropdown?filterby=Status_equal=Active&optionsonly=true'));
				
				//if post id is given in url
				if(!empty($wrapper['post_id'])){
					$wrapper['job_definition_options'] = str_ireplace("value=\"".$wrapper['post_id']."\"", "value=\"".$wrapper['post_id']."\" selected=\"selected\" ", $wrapper['job_definition_options']);
				}//endif
			break;
		}
		
		$wrapper['message'] = $message;
		$wrapper['mode'] = $mode;
		$this->load->view('job_applications_form',$wrapper);
	}
	
	/**
	 * Function get_data_form
	 *
	 *
	 * function handaling form add,edit,delete and view features
	 *
	 * @param  $data stirng values, key
	 * @param  $mode strign, forms type add, edit, delete, view
	 * @return
	 * @access
	 * @since	1.0
	 */
	function get_data_form($mode='add',$data = null){
		$this->log_create->set_otherDetails(array('Mode'=>$mode?$mode:'-','Data'=>$_POST?serialize($this->input->post()):($data!=''?$data:'-')));
		$this->log_create->init();
		$data2save = array();
		$key2save = array();
		$message = array('msgText'=>'','msgType'=>'','focusField'=>'');
		
		if($mode != 'add'){
			$limit = 0;
			$offset = 0;
				
			$row = $this->job_applications_model->get_data(
					array(
							'search'=>array(array('search_field' => 'job_applications.id', 'search_text' => $data, 'query_method'=>'equal')),
							'limit' => $limit,
							'offset'=>$offset
					)
			);
			$w = $row['result_set'][1]; //should we validate if there is records?
			foreach ($w as $c=>$v){ $wrapper[$c] = $v; }
			
			/* $academicqrow = $this->Academic_qualifications_model->get_data(array(
  			'search'=>array(array('search_field' => 'Academic_qualifications.application_id','search_text' => $data,'query_method'=>'equal')),
  			'limit' => 0, 'offset'=>0
  			));
  			$wrapper['academicqdata'] = $academicqrow['result_set']; */
		}
		
		if($_POST){
			//$postData = $this->input->post();
			$postData = $_POST;
				
			foreach($postData as $c=>$v){
				if($c!='mode' && $c!='formstatus'){
					$data2save[$c] = $v;
				}
				$wrapper[$c] = $v;
			}
			if($this->input->post('id') !=''){
				$key2save = array('id' =>$this->input->post('id'));
			}
		}
		
		switch ($mode){
			case "add": //-----------------------------------------------------
				//Check duplicates
				if ($this->input->post('first_name')) {
					if ($this->job_applications_model->exists(array('first_name' => $this->input->post('first_name')))) {
						$message['msgText'] ='Sorry this record already exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='first_name';
					}
					else{
						$msg = $this->job_applications_model->save($data2save,$key2save);
						
						//$qinsert = $this->Interview_questions_model->save($q_data2save,$q_key2save);
						//$IQ_id = $this->db->insert_id();
						if ($msg) {
							$message['msgText'] ='<span style="color:#008000;">Record successfully created!</span>';
							$message['msgType'] ='success';
							$message['gridHandler'] ='updateAndClose';
						}
						else{
							$message['msgText'] =$msg;
							$message['msgType'] ='failure';
							$message['focusField'] ='first_name';
						}
					}
				}
				break;
			case "edit":
				//Do validations if form submitted based on POST var
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_applications_model->exists(array('id' => $this->input->post('id')))) {
						$message['msgText'] ='Sorry this record does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='first_name';
					}
					else{//Valid key
						//checking existance
						if ($this->job_applications_model->exists(array('first_name' => $this->input->post('first_name'),'id !=' => $this->input->post('id')))){
							$message['msgText'] ='Sorry this record already exist!';
							$message['msgType'] ='failure';
							$message['focusField'] ='first_name';
						}
						else{
							$msg = $this->job_applications_model->save($data2save,$key2save);
							if ($msg) {
								$message['msgText'] ='<span style="color:#008000;">Record successfully updated!</span>';
								$message['msgType'] ='success';
								$message['gridHandler'] ='updateAndClose';
							}else{
								$message['msgText'] =$msg;
								$message['msgType'] ='failure';
								$message['focusField'] ='first_name';
							}
						}
					}
					//end validation & save
				}
				break;
			case "delete":
				//Do validations if form submitted based on POST var
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_applications_model->exists(array('id' => $this->input->post('id')))) {
						$message['msgText'] ='Sorry this record does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='';
					}
				}
				break;
			case "view":
				
				$wrapper['job_definition_options'] = get_contents_with_session(site_url('/job_definitions/createDropdown?filterby=Status_equal=Active&optionsonly=true'));
	
				//if post id is given in url
				if(!empty($wrapper['post_id'])){
					
					$wrapper['job_definition_options'] = str_ireplace("value=\"".$wrapper['post_id']."\"", "value=\"".$wrapper['post_id']."\" selected=\"selected\" ", $wrapper['job_definition_options']);
					
				}//endif
				break;
		}
		
		$wrapper['message'] = $message;
		
		$wrapper['mode'] = $mode;

		$this->load->view('job_applications_form_view',$wrapper);
		
	}
	
	/**
	 * Function get_data_form
	 *
	 *
	 * function handaling form add,edit,delete and view features
	 *
	 * @param  $data stirng values, key
	 * @param  $mode strign, forms type add, edit, delete, view
	 * @return
	 * @access
	 * @since	1.0
	 */
	function view_data_form($mode='add',$data = null){
		$this->log_create->set_otherDetails(array('Mode'=>$mode?$mode:'-','Data'=>$_POST?serialize($this->input->post()):($data!=''?$data:'-')));
		$this->log_create->init();
		$data2save = array();
		$key2save = array();
		$message = array('msgText'=>'','msgType'=>'','focusField'=>'');
	
		if($mode != 'add'){
			$limit = 0;
			$offset = 0;
	
			$row = $this->job_applications_model->get_data(
					array(
							'search'=>array(array('search_field' => 'job_applications.id', 'search_text' => $data, 'query_method'=>'equal')),
							'limit' => $limit,
							'offset'=>$offset
					)
			);
			$w = $row['result_set'][1]; //should we validate if there is records?
			foreach ($w as $c=>$v){ $wrapper[$c] = $v; }
				
			$academicqrow = $this->Academic_qualifications_model->get_data(array(
  			'search'=>array(array('search_field' => 'academic_qualifications.application_id','search_text' => $data,'query_method'=>'equal')),
  			'limit' => 0, 'offset'=>0
  			));
			//print_r($academicqrow);
  			$wrapper['academicqdata'] = $academicqrow['result_set'];
  			$professqrow = $this->Professional_qualifications_model->get_data(array(
  					'search'=>array(array('search_field' => 'professional_qualifications.application_id','search_text' => $data,'query_method'=>'equal')),
  					'limit' => 0, 'offset'=>0
  			));
  			$wrapper['professiqdata'] = $professqrow['result_set'];
  			$professqrow = $this->Professional_qualifications_model->get_data(array(
  					'search'=>array(array('search_field' => 'professional_qualifications.application_id','search_text' => $data,'query_method'=>'equal')),
  					'limit' => 0, 'offset'=>0
  			));
  			$wrapper['professiqdata'] = $professqrow['result_set'];
  			
  			$workexperow = $this->Work_experience_model->get_data(array(
  					'search'=>array(array('search_field' => 'work_experience.application_id','search_text' => $data,'query_method'=>'equal')),
  					'limit' => 0, 'offset'=>0
  			));
  			$wrapper['workexpedata'] = $workexperow['result_set'];
  			
  			//foreach ($academicqrow as $c=>$v){ print_r ($v); }  
		}
	
		if($_POST){
			//$postData = $this->input->post();
			$postData = $_POST;
	
			foreach($postData as $c=>$v){
				if($c!='mode' && $c!='formstatus'){
					$data2save[$c] = $v;
				}
				$wrapper[$c] = $v;
			}
			if($this->input->post('id') !=''){
				$key2save = array('id' =>$this->input->post('id'));
			}
		}
	
		switch ($mode){
			case "add": //-----------------------------------------------------
				//Check duplicates
				if ($this->input->post('first_name')) {
					if ($this->job_applications_model->exists(array('first_name' => $this->input->post('first_name')))) {
						$message['msgText'] ='Sorry this record already exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='first_name';
					}
					else{
						$msg = $this->job_applications_model->save($data2save,$key2save);
	
						//$qinsert = $this->Interview_questions_model->save($q_data2save,$q_key2save);
						//$IQ_id = $this->db->insert_id();
						if ($msg) {
							$message['msgText'] ='<span style="color:#008000;">Record successfully created!</span>';
							$message['msgType'] ='success';
							$message['gridHandler'] ='updateAndClose';
						}
						else{
							$message['msgText'] =$msg;
							$message['msgType'] ='failure';
							$message['focusField'] ='first_name';
						}
					}
				}
				break;
			case "edit":
				//Do validations if form submitted based on POST var
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_applications_model->exists(array('id' => $this->input->post('id')))) {
						$message['msgText'] ='Sorry this record does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='first_name';
					}
					else{//Valid key
						//checking existance
						if ($this->job_applications_model->exists(array('first_name' => $this->input->post('first_name'),'id !=' => $this->input->post('id')))){
							$message['msgText'] ='Sorry this record already exist!';
							$message['msgType'] ='failure';
							$message['focusField'] ='first_name';
						}
						else{
							$msg = $this->job_applications_model->save($data2save,$key2save);
							if ($msg) {
								$message['msgText'] ='<span style="color:#008000;">Record successfully updated!</span>';
								$message['msgType'] ='success';
								$message['gridHandler'] ='updateAndClose';
							}else{
								$message['msgText'] =$msg;
								$message['msgType'] ='failure';
								$message['focusField'] ='first_name';
							}
						}
					}
					//end validation & save
				}
				break;
			case "delete":
				//Do validations if form submitted based on POST var
				if ($this->input->post('id')) {
					//check for prime key existance
					if (!$this->job_applications_model->exists(array('id' => $this->input->post('id')))) {
						$message['msgText'] ='Sorry this record does not exist!';
						$message['msgType'] ='failure';
						$message['focusField'] ='';
					}
				}
				break;
			case "view":
	
				$wrapper['job_definition_options'] = get_contents_with_session(site_url('/job_definitions/createDropdown?filterby=Status_equal=Active&optionsonly=true'));
	
				//if post id is given in url
				if(!empty($wrapper['post_id'])){
						
					$wrapper['job_definition_options'] = str_ireplace("value=\"".$wrapper['post_id']."\"", "value=\"".$wrapper['post_id']."\" selected=\"selected\" ", $wrapper['job_definition_options']);
						
				}//endif
				break;
		}
	
		$wrapper['message'] = $message;
	
		$wrapper['mode'] = $mode;
	
		$this->load->view('job_applications_form_new_view',$wrapper);   
	
	}
	
	
	function apply_form(){
		$this->log_create->set_otherDetails(array('Mode'=>'Apply_form','Data'=>$_POST?serialize($this->input->post()):'-'));
		$this->log_create->init();
		
		$wrapper = array();
		$debug = false;
		$file_upload_result = null;
		$msg = null;
		$dup_data = null;
		
		if($debug)log_message('debug','job definitils options list :-'.print_r($job_definition_options,true));
		$app_data = $this->input->post(null,true);
		$wrapper['post_id'] =  $this->input->get('post_id',true);//this post id is comming from calling url
		
		@session_start();
		$wrapper['pid'] =  (!empty($_SESSION['pid']))?$_SESSION['pid']:null;
		$wrapper['job_definition_options'] = get_contents_with_session(site_url('/job_definitions/createDropdown?filterby=Status_equal=Active&optionsonly=true'));
		
		//if post id is given in url
		if(!empty($wrapper['post_id'])){
			$wrapper['job_definition_options'] = str_ireplace("value=\"".$wrapper['post_id']."\"", "value=\"".$wrapper['post_id']."\" selected=\"selected\" ", $wrapper['job_definition_options']);
		}//endif
		
		$wrapper['app_date'] = date('Y-m-d');
		$wrapper['msg'][] = $msg;	
		$wrapper['form_data'] = $app_data;
		
		//when application form is submitted		
		if(!empty($app_data['post_id']) && !empty($app_data['first_name']) && !empty($app_data['last_name'])){
			// filter form data from unwanted fields
			foreach($app_data as $c=>$v){
				if($c!='mode' && $c!='formstatus' && $c !='MAX_FILE_SIZE' ){
					$app_data[$c] = $v;
				}
				else{
					unset($app_data[$c]);
				}
			}//end foreach
			
			//since job definition options are in string format, do simple str replace function to select exact selected option.
			$wrapper['job_definition_options'] = str_ireplace("value=\"".$app_data['post_id']."\"", "value=\"".
					$app_data['post_id']."\" selected=\"selected\" ", $wrapper['job_definition_options']);
			
			$this->handle_file_uploads($app_data,$wrapper);	
		}
		else{
			if(!empty($wrapper['pid'])){
				//if post id is given in url
				if(!empty($wrapper['post_id'])){
					$wrapper['job_definition_options'] = str_ireplace("value=\"".$wrapper['post_id']."\"", "value=\"".
							$wrapper['post_id']."\" selected=\"selected\" ", $wrapper['job_definition_options']);
				}//endif
								
				$result = $this->profiles_model->get_data(
					array(
						'search'=>array(array('search_field' => 'pid', 'search_text' => $wrapper['pid'], 'query_method'=>'equal')),
						'limit' => 1, 'offset'=> 0,
						'order_by'=>array('profiles.pid'=>'Asc')
					)
				);
				
				if(!empty($result['result_set'])){
					$result['result_set'][1]['applicant_image'] = $result['result_set'][1]['applicant_image'];
					$result['result_set'][1]['cv_path'] = $result['result_set'][1]['cv_path'];
					$result['result_set'][1]['cv_name'] = basename($result['result_set'][1]['cv_path']);
					$wrapper['form_data'] = $result['result_set'][1];					
				}					
				$this->load->view('apply_now',$wrapper);				
			}
			else{
				$this->load->view('apply_now',$wrapper);
			}//end if
		}//end if post
	}//end of function
	
	/**
	 * Function new_apply_form
	 *
	 *
	 * Multiline detail description of the file goes here. you may
	 * give any type of details here such as usage and examples
	 *
	 * @param		None
	 * @return		void
	 * @access		public
	 * @since		3.0
	 */
	
	function new_apply_form(){
		$this->log_create->set_otherDetails(array('Mode'=>'Apply_form','Data'=>$_POST?serialize($this->input->post()):'-'));
		$this->log_create->init();
		//echo "postdata1 "; 
		$wrapper = array();
		$debug = false;
		$file_upload_result = null;
		$msg = null;
		$dup_data = null;
		$post_proffe_data=array();
		$post_academic_data=array();
		$post_exper_data=array();
	
		if($debug)log_message('debug','job definitils options list :-'.print_r($job_definition_options,true));
		
		 $app_data = $this->input->post(null,true); 
		
		if(!empty($app_data['post_id']) && !empty($app_data['first_name']) && !empty($app_data['last_name'])){
		//echo "postdata2 "; 
		
		
		foreach($app_data as $c=>$v){
			if($c=="profeQualification"){
				$post_proffe_data=$app_data['profeQualification'];
				unset($app_data[$c]);
			}
			elseif ($c=="acaQualification"){
				$post_academic_data=$app_data['acaQualification'];
				unset($app_data[$c]);
			}
			elseif ($c=="experience"){
				$post_exper_data=$app_data['experience'];
				unset($app_data[$c]);
			}
			elseif ($c=="have_acv"){
				unset($app_data[$c]);
			}
			
			}//end foreach
		}
			
		$wrapper['post_id'] =  $this->input->get('post_id',true);//this post id is comming from calling url
	
		@session_start();
		$wrapper['pid'] =  (!empty($_SESSION['pid']))?$_SESSION['pid']:null;
		$wrapper['job_definition_options'] = get_contents_with_session(site_url('/job_definitions/createDropdown?filterby=Status_equal=Active&optionsonly=true'));
	
		//if post id is given in url
		if(!empty($wrapper['post_id'])){
			$wrapper['job_definition_options'] = str_ireplace("value=\"".$wrapper['post_id']."\"", "value=\"".$wrapper['post_id']."\" selected=\"selected\" ", $wrapper['job_definition_options']);
		}//endif
	
		$wrapper['app_date'] = date('Y-m-d');
		$wrapper['msg'][] = $msg;
		$wrapper['form_data'] = $app_data;
	
		//when application form is submitted
		if(!empty($app_data['post_id']) && !empty($app_data['first_name']) && !empty($app_data['last_name'])){
			// filter form data from unwanted fields
			foreach($app_data as $c=>$v){
				if($c!='mode' && $c!='formstatus' && $c !='MAX_FILE_SIZE' ){
					$app_data[$c] = $v;
				}
				else{
					unset($app_data[$c]);
				}
			}//end foreach
				
			//since job definition options are in string format, do simple str replace function to select exact selected option.
			$wrapper['job_definition_options'] = str_ireplace("value=\"".$app_data['post_id']."\"", "value=\"".
					$app_data['post_id']."\" selected=\"selected\" ", $wrapper['job_definition_options']);
				
			$this->new_handle_file_uploads($app_data,$wrapper,$post_proffe_data,$post_academic_data,$post_exper_data);
		}
		else{
			if(!empty($wrapper['pid'])){
				//if post id is given in url
				if(!empty($wrapper['post_id'])){
					$wrapper['job_definition_options'] = str_ireplace("value=\"".$wrapper['post_id']."\"", "value=\"".
							$wrapper['post_id']."\" selected=\"selected\" ", $wrapper['job_definition_options']);
				}//endif
	
				$result = $this->profiles_model->get_data(
						array(
								'search'=>array(array('search_field' => 'pid', 'search_text' => $wrapper['pid'], 'query_method'=>'equal')),
								'limit' => 1, 'offset'=> 0,
								'order_by'=>array('profiles.pid'=>'Asc')
						)
				);
	
				if(!empty($result['result_set'])){
					$result['result_set'][1]['applicant_image'] = $result['result_set'][1]['applicant_image'];
					$result['result_set'][1]['cv_path'] = $result['result_set'][1]['cv_path'];
					$result['result_set'][1]['cv_name'] = basename($result['result_set'][1]['cv_path']);
					$wrapper['form_data'] = $result['result_set'][1];
				}
				$this->load->view('new_apply_now',$wrapper);
			}
			else{
				$this->load->view('new_apply_now',$wrapper);
			}//end if
		}//end if post
	}//end of function
	
	
	/**
	 * Function send_cron
	 *
	 *
	 * Multiline detail description of the file goes here. you may 
	 * give any type of details here such as usage and examples
	 *
	 * @param		None
	 * @return		void
	 * @access		public
	 * @since		3.0
	 */
	function send_cron(){
		$this->load->model('interview_schedules_model');
		$current_date = date("Y-m-d");
		$schedules_data = $this->interview_schedules_model->get_data(array(
			'search'=>array(
				array('search_field'=>"interview_schedules.scheduled_datetime", 'search_text'=>$current_date, 	'query_method'=>"like"),
				array('search_field'=>"interview_schedules.status", 			'search_text'=>"pending", 		'query_method'=>"equal"),
				array('search_field'=>"interview_schedules.type", 				'search_text'=>"test", 			'query_method'=>"equal")
			),
			'limit'=>0, 'offset'=>0, 'order_by'=>array('interview_schedules.IS_id'=>'Asc')
		));
		
		$app_id = 0;
		$msg = '';
		foreach ($schedules_data['result_set'] as $key=>$values){
			if($app_id==0){
				//send test
				$this->send_test($values['app_id']);
				$app_id = $values['app_id'];
				$msg = "$msg|$app_id , ";
			}
			if($app_id!=$values['app_id']){
				//send test
				$this->send_test($values['app_id']);
				$app_id = $values['app_id'];
				$msg = "$msg|$app_id , ";
			}
		}
		$subject= "Test Cron send apps";
		$to		= "nuwan@ekwa.com";
		email_send($subject,$msg,$to);
	}
	
	
	/**
	 * Function send_test
	 *
	 *
	 * this function use to send testing to selected applicant if auto sending testing not working or
	 * applicant miss the mail auto send by system
	 *
	 * @param		$data string, applicant ID (app_id)
	 * @return		void
	 * @access		public
	 * @since		3.0
	 */
	function send_test($data){
		$this->log_create->set_otherDetails(array('Mode'=>'Send_test','Data'=>$_POST?serialize($this->input->post()):'-'));
		$this->log_create->init();
		
		//getting interview datas as json
		$interview_data = get_contents_with_session(site_url()."/interview_schedules/get_app_post_inter_def_details/$data");
		$interview_data = objectToArray(json_decode($interview_data));//decoding json data and convert it to array
		/*
		 * passing data
		 * [1] => Array(
		 * 		[ID_id] => 25
		 * 		[name] => SEO-CAM work form home
		 * 		[post_id] => 33
		 * 		[definition] => {
		 * 			"1":{"staff_id":"290","details":"testing 1st interview step","type":"interview"},
		 * 			"2":{"test_id":"15","type":"test"},
		 * 			"3":{"staff_id":"181","details":"testing 3rd interview step","type":"interview"}
		 * 		}
		 * 		[designation] => SEO Client Account Manager (Work from Home)
		 * )
		 * [app_full_name] => test 3 test 3
		 * [app_status] => SHORTLISTED
		 * [no_of_previous_steps] => 1
		 * 
		 */
		
		//get step data
		$definition = objectToArray(json_decode($interview_data[1]['definition']));
		$definition = $definition[$interview_data['no_of_previous_steps']+1];
		
		if($definition['type']=='test'){
			//getting applicant email id and name
			$applicant_date = $this->job_applications_model->get_data(
				array(
					'search'=>array(array('search_field'=>'job_applications.id', 'search_text'=>$data, 'query_method'=>'equal')),
					'limit'=>0, 'offset'=>0
				)
			);
			
			//get test mail template data from job definition
			$job_definition = $this->Job_definitions_model->get_data(
				array(
					'search'=>array(array('search_field'=>'id', 'search_text'=>$interview_data[1]['post_id'], 'query_method'=>'equal')),
					'limit'=>0, 'offset'=>0
				)
			);
			
			$update_array['TITLE']		= $applicant_date['result_set'][1]['title'];
			$update_array['FIRSTNAME']	= $applicant_date['result_set'][1]['first_name'];
			$update_array['LASTNAME']	= $applicant_date['result_set'][1]['last_name'];
			
			$msg = template_update($job_definition['result_set'][1]['trade_test'], 'test', $update_array);
			
			//adding test view link to text
			$test_link = site_url()."/interview_tests/landing_test/?test_id=".$definition['test_id']."&app_id=$data";
			$doc = new DOMDocument();
			$doc->loadHTML($msg);
			$as = $doc->getElementsByTagName('a');
			foreach( $as as $a ){
				$a->setAttribute("href", $test_link);
			}
			
			$msg	= $doc->saveHTML();
			$subject= $interview_data[1]['designation']." post Test";
			$to		= $applicant_date['result_set'][1]['email'];
			email_send($subject,$msg,$to);
			
			//applicant status updating to Test Given
			echo $this->update_status('test_given',$data);
		}else{
			echo '0';
		}
	}
	
	
	/**
	 * Function send_letter
	 *
	 *
	 * this function use to send offering letter to manual using email
	 *
	 * @param		$data string, applicant ID (app_id)
	 * @return		void
	 * @access		public
	 * @since		3.0
	 */
	function send_letter($data, $ext){
		$this->log_create->set_otherDetails(array('Mode'=>'Send_letter','Data'=>$_POST?serialize($this->input->post()):($data!=''?$data.','.$ext:'-')));
		$this->log_create->init();
		
		//getting applicant email/name/post ID
		$applicant_date = $this->job_applications_model->get_data(array(
			'search'=>array(array('search_field'=>'job_applications.id', 'search_text'=>$data, 'query_method'=>'equal')),
			'limit'=>0, 'offset'=>0
		));
		$applicant_date = $applicant_date['result_set'][1];
		
		//get offering letter
		$job_definition = $this->Job_definitions_model->get_data(array(
			'search'=>array(array('search_field'=>'id', 'search_text'=>$applicant_date['post_id'], 'query_method'=>'equal')),
			'limit'=>0, 'offset'=>0
		));
		$job_definition = $job_definition['result_set'][1];
		
		$update_array['TITLE']		= $applicant_date['title'];
		$update_array['FIRSTNAME']	= $applicant_date['first_name'];
		$update_array['LASTNAME']	= $applicant_date['last_name'];
		$update_array['DATE']		= date("Y-m-d");
		$msg = template_update($job_definition['offer_template'], 'offer', $update_array);
		$msg = $msg."<br/><br/> <a href='".site_url()."/job_applications/submit_letter/$data' target='_blank'> Please use this link to submit signed offer letter.</a>";
		
		$subject= $job_definition['designation']." - Offer Letter";
		$to		= $applicant_date['email'];
		
		$files_path = './public/uploads/send_offer_letters/';
		$file_name	= $update_array['FIRSTNAME']."_".$update_array['LASTNAME']."_offerletter.$ext";
		$file_name	= str_replace(' ','_',$file_name);
		$full_name	= $files_path.$file_name;
		
		$testing = email_send($subject, $msg, $to, '0', '0', '0', $full_name);
		//echo"<pre>";print_r($testing);echo "</pre>";
		
		//add data to offer letter table
		$key = array();
		$save_data['app_id']		= $data;
		$save_data['letter_name']	= $file_name;
		$save_data['send_date']		= date("Y-m-d");
		$save_data['send_by']		= $_SESSION['user_id'];
		$save_data['status']		= "send";
		$this->Offer_letter_model->save($save_data, $key);
		
		//applicant status updating to Test Given
		$this->update_status('offer_submitted',$data);
	}
	
	
	/**
	 * Function uploadfile
	 *
	 *
	 * Multiline detail description of the file goes here. you may 
	 * give any type of details here such as usage and examples
	 *
	 * @param	None
	 * @return	void
	 * @access	public
	 * @since	3.0	
	 */
	function uploadfile($type='send'){
		if(isset($_POST['app_id'])){
			$applicant_date = $this->job_applications_model->get_data(array(
				'search'=>array(array('search_field'=>'job_applications.id', 'search_text'=>$_POST['app_id'], 'query_method'=>'equal')),
				'limit'=>0, 'offset'=>0
			));
			
			$newfilename = $applicant_date['result_set'][1]['first_name']."_".$applicant_date['result_set'][1]['last_name']."_offerletter";
			$config['upload_path'] 	= './public/uploads/send_offer_letters/';
			$config['allowed_types']= 'gif|jpg|jpeg|png|doc|pdf|docx';
			$config['max_size']		= '0';
			$config['max_width'] 	= '0';
			$config['max_height'] 	= '0';
			$config['overwrite'] 	= TRUE;
			$config['file_name'] 	= $newfilename;
			
			$this->load->library('upload', $config);
			$field_name = "offer_letter_file";
			
			if(!$this->upload->do_upload($field_name)){ print_r($this->upload->display_errors()); }
			else{ echo '1'; }
		}
	}
	
	
	/**
	 * Function submit_letter
	 *
	 *
	 * Multiline detail description of the file goes here. you may 
	 * give any type of details here such as usage and examples
	 *
	 * @param		$data String, application id
	 * @return		void
	 * @access		public
	 * @since		3.0
	 */
	function submit_letter($data=''){
		$this->log_create->set_otherDetails(array('Mode'=>'Submit_letter','Data'=>$_POST?serialize($this->input->post()):($data!=''?$data:'-')));
		$this->log_create->init();
		
		$wrapper['msg'] = array();
		if(isset($_POST['app_id'])){
			$applicant_date = $this->job_applications_model->get_data(array(
				'search'=>array(array('search_field'=>'job_applications.id', 'search_text'=>$_POST['app_id'], 'query_method'=>'equal')),
				'limit'=>0, 'offset'=>0
			));
			$applicant_date = $applicant_date['result_set'][1];
			
			$newfilename = $applicant_date['first_name']."_".$applicant_date['last_name']."_offerletter";
			$config['upload_path'] 	= './public/uploads/reply_offer_letters/';
			$config['allowed_types']= 'gif|jpg|jpeg|png|doc|pdf|docx';
			$config['max_size']		= '0';
			$config['max_width'] 	= '0';
			$config['max_height'] 	= '0';
			$config['overwrite'] 	= TRUE;
			$config['file_name'] 	= $newfilename;
			
			$this->load->library('upload', $config);
			$field_name = "offer_letter_file";
			
			if($this->upload->do_upload($field_name)){
				$file_data = $this->upload->data('file_name');
				
				$app_name = $applicant_date['first_name']."_".$applicant_date['last_name'];
				$msg = "Dear PDA,<br/><br/>";
				$msg .= "This is to inform you that $app_name submitted signed offer letter on ".$_POST['date'];
				$msg .= "<br/><br/>";
				$msg .= 'Please check HRM system "Applications" to download signed offer letter and start hiring process.';
				$msg .= "<br/><br/>Thank you.<br/><br/>HRM system - PDA Team.";
				$subject= "$app_name - Signed offer letter";
				$to		= PDA_EMAIL;
				
				$files_path = './public/uploads/reply_offer_letters/';
				$file_name	= $file_data['file_name'];
				$full_name	= $files_path.$file_name;
				email_send($subject, $msg, $to, '0', '0', '0', $full_name);
				
				//add data to offer letter table
				$offer_letter = $this->Offer_letter_model->get_data(array(
					'search'=>array(array('search_field'=>'offer_letter.app_id', 'search_text'=>$_POST['app_id'], 'query_method'=>'equal')),
					'limit'=>0, 'offset'=>0, 'order_by'=>array('offer_letter.offer_id'=>'Desc')
				));
				
				$key_offer['offer_id']		= $offer_letter['result_set'][1]['offer_id'];
				$save_offer['reply_date']	= $_POST['date'];
				$save_offer['status']		= "reply";
				$this->Offer_letter_model->save($save_offer, $key_offer);
				
				//applicant status updating to Test Given
				echo $this->update_status('review_letter',$_POST['app_id']);
			}
		}else{
			$applicant_date = $this->job_applications_model->get_data(array(
				'search'=>array(array('search_field'=>'job_applications.id', 'search_text'=>$data, 'query_method'=>'equal')),
				'limit'=>0, 'offset'=>0
			));
			$wrapper['name']= $applicant_date['result_set'][1]['first_name']." ".$applicant_date['result_set'][1]['last_name'];
			$wrapper['designation']= $applicant_date['result_set'][1]['designation'];
			$wrapper['data']= $data;
			$this->load->view('submit_letter',$wrapper);
		}
	}
	
	
	/**
	 * Function hire_applicant
	 *
	 *
	 * this function handle hire form loading and updating offer_letter table with status and hire date
	 *
	 * @param		$data String, applicant ID
	 * @return		void
	 * @access		public
	 * @since		3.0
	 */
	function hire_applicant($data=''){
		$this->log_create->set_otherDetails(array('Mode'=>'Hire applicant','Data'=>$_POST?serialize($this->input->post()):($data!=''?$data:'-')));
		$this->log_create->init();
		
		$wrapper = '';
		if(isset($_POST['offer_id'])){
			//offer letter table update
			$key_offer['offer_id']		= $_POST['offer_id'];
			
			$save_offer['review_date']	= $_POST['review_date'];
			$save_offer['review_by']	= $_SESSION['user_id'];
			$save_offer['hire_date']	= $_POST['hire_date'];
			if(isset($_POST['status']) && $_POST['status']!=''){
				$save_offer['status']		= $_POST['status'];
			}
			$this->Offer_letter_model->save($save_offer, $key_offer);
			
			//application status changing
			$this->update_status('hire_app',$_POST['app_id']);
			
			$message['msgText'] ='<span style="color:#008000;">Offer letter successfully accepted!</span>'; 
			$message['msgType'] ='success';
			$message['gridHandler'] ='updateAndClose';
			$wrapper['message'] = $message;
		}
		
		$offer_letter_data = $this->Offer_letter_model->get_data(array(
			'search'=>array(array('search_field'=>'offer_letter.app_id', 'search_text'=>$data, 'query_method'=>'equal')),
			'limit'=>0, 'offset'=>0, 'order_by'=>array('offer_letter.offer_id'=>'Desc')
		));
		$offer_data = $offer_letter_data['result_set'][1];
		
		$wrapper['offer_id']	= $offer_data['offer_id'];
		$wrapper['app_id']		= $offer_data['app_id'];
		$wrapper['full_name']	= $offer_data['first_name']." ".$offer_data['last_name'];
		$wrapper['reply_date']	= $offer_data['reply_date'];
		$wrapper['review_date']	= $offer_data['review_date'];
		$wrapper['status']		= $offer_data['status'];
		$wrapper['hire_date']	= $offer_data['hire_date'];
		$wrapper['download_url']= base_url()."public/uploads/reply_offer_letters/".$offer_data['letter_name'];
		$this->load->view('hire_form', $wrapper);
	}
	
	/**
	 * Function get_hire_applicant
	 *
	 *
	 * this function handle hire form loading and updating offer_letter table with status and hire date
	 *
	 * @param		$data String, applicant ID
	 * @return		void
	 * @access		public
	 * @since		3.0
	 */
	function get_hire_applicant($data=''){
		$this->log_create->set_otherDetails(array('Mode'=>'Hire applicant','Data'=>$_POST?serialize($this->input->post()):($data!=''?$data:'-')));
		$this->log_create->init();
	
		$wrapper = '';
		if(isset($_POST['offer_id'])){
			//offer letter table update
			$key_offer['offer_id']		= $_POST['offer_id'];
				
			$save_offer['review_date']	= $_POST['review_date'];
			$save_offer['review_by']	= $_SESSION['user_id'];
			$save_offer['hire_date']	= $_POST['hire_date'];
			if(isset($_POST['status']) && $_POST['status']!=''){
				$save_offer['status']		= $_POST['status'];
			}
			$this->Offer_letter_model->save($save_offer, $key_offer);
				
			//application status changing
			$this->update_status('hire_app',$_POST['app_id']);
				
			$message['msgText'] ='<span style="color:#008000;">Offer letter successfully accepted!</span>';
			$message['msgType'] ='success';
			$message['gridHandler'] ='updateAndClose';
			$wrapper['message'] = $message;
		}
	
		$offer_letter_data = $this->Offer_letter_model->get_data(array(
				'search'=>array(array('search_field'=>'offer_letter.app_id', 'search_text'=>$data, 'query_method'=>'equal')),
				'limit'=>0, 'offset'=>0, 'order_by'=>array('offer_letter.offer_id'=>'Desc')
		));
		$offer_data = $offer_letter_data['result_set'][1];
	
		$wrapper['offer_id']	= $offer_data['offer_id'];
		$wrapper['app_id']		= $offer_data['app_id'];
		$wrapper['full_name']	= $offer_data['first_name']." ".$offer_data['last_name'];
		$wrapper['reply_date']	= $offer_data['reply_date'];
		$wrapper['review_date']	= $offer_data['review_date'];
		$wrapper['status']		= $offer_data['status'];
		$wrapper['hire_date']	= $offer_data['hire_date'];
		$wrapper['download_url']= base_url()."public/uploads/reply_offer_letters/".$offer_data['letter_name'];
		$this->load->view('hire_form_view', $wrapper);
	}
	
	
	function check_blacklist($app_data){
		//TODO
	}//end of function
	
	
	function handle_file_uploads($app_data,$wrapper){
		$error_msg = array();
		
		if(!empty($_FILES["applicant_image"]['name'])){
			
			$allowed =  array('gif','png' ,'jpg');
			$filename = $_FILES['applicant_image']['name'];
			$ext = pathinfo($filename, PATHINFO_EXTENSION);
			
			if(in_array($ext,$allowed)) {
				$finame_ext = explode('.',$filename);
					
				$filename = './public/uploads/' . $app_data['first_name'].'_'. $app_data['last_name']. '.'. $ext;
				$_FILES["applicant_image"]['name'] = $app_data['first_name'].'_'. $app_data['last_name']. '.'. $ext;				
					
				if (!is_uploaded_file($_FILES['applicant_image']['tmp_name']) or !copy($_FILES['applicant_image']['tmp_name'], $filename)){
					
					$error_msg['applicant_image']['error_msg'] = "Could not  save file as $filename! -- ".$_FILES['applicant_image']['error'];
					log_message('error','File upload error: '.$error_msg['applicant_image']['error_msg']);
				}else{
					$app_data['applicant_image'] = $filename;
				}
			}else{
				$error_msg[] = array('type'=>'error','msg'=>'The image file you have uploaded is incompatible. Please upload a gif,png or jpg image!');
			}
		}
		
		if(!empty($_FILES["cv_file"]['name'])){
			$allowed =  array('pdf','doc' ,'txt','docx');
			$filename = $_FILES['cv_file']['name'];
			$ext = pathinfo($filename, PATHINFO_EXTENSION);
			
			if(in_array($ext,$allowed)) {
				$finame_ext = explode('.',$filename);
				
				// The complete path/filename
				$filename = './public/uploads/' . $app_data['first_name'].'_'. $app_data['last_name'].'_cv'. '.'. $ext;
				if (!is_uploaded_file($_FILES['cv_file']['tmp_name']) or !copy($_FILES['cv_file']['tmp_name'], $filename)){
					$error_msg['cv_file']['error_msg'] = "Could not  save file as $filename! -- Error Code :".$_FILES['cv_file']['error'];
					log_message('error','File upload error: '.$error_msg['cv_file']['error_msg']);
				}else{
					$app_data['cv_path'] = $filename;
				}
			}else{
				$error_msg[] = array('type'=>'error','msg'=> 'The CV you have uploaded is incompatible. Please upload a pdf,doc,docx or txt file!');
			}//end if
		}//endif
		
		if(empty($error_msg)){
			$this->duplicate_entry_check($app_data,$wrapper);
		}else{
			$wrapper['msg']= $error_msg;
			$this->load->view('apply_now',$wrapper);
		}//end if error msg check
	}//end of function
	

	function new_handle_file_uploads($app_data,$wrapper,$post_proffe_data,$post_academic_data,$post_exper_data){
		$error_msg = array();
	
		if(!empty($_FILES["applicant_image"]['name'])){
				
			$allowed =  array('gif','png' ,'jpg');
			$filename = $_FILES['applicant_image']['name'];
			$ext = pathinfo($filename, PATHINFO_EXTENSION);
				
			if(in_array($ext,$allowed)) {
				$finame_ext = explode('.',$filename);
					
				$filename = './public/uploads/' . $app_data['first_name'].'_'. $app_data['last_name']. '.'. $ext;
				$_FILES["applicant_image"]['name'] = $app_data['first_name'].'_'. $app_data['last_name']. '.'. $ext;
					
				if (!is_uploaded_file($_FILES['applicant_image']['tmp_name']) or !copy($_FILES['applicant_image']['tmp_name'], $filename)){
						
					$error_msg['applicant_image']['error_msg'] = "Could not  save file as $filename! -- ".$_FILES['applicant_image']['error'];
					log_message('error','File upload error: '.$error_msg['applicant_image']['error_msg']);
				}else{
					$app_data['applicant_image'] = $filename;
				}
			}else{
				$error_msg[] = array('type'=>'error','msg'=>'The image file you have uploaded is incompatible. Please upload a gif,png or jpg image!');
			}
		}
	
		if(!empty($_FILES["cv_file"]['name'])){
			$allowed =  array('pdf','doc' ,'txt','docx');
			$filename = $_FILES['cv_file']['name'];
			$ext = pathinfo($filename, PATHINFO_EXTENSION);
				
			if(in_array($ext,$allowed)) {
				$finame_ext = explode('.',$filename);
	
				// The complete path/filename
				$filename = './public/uploads/' . $app_data['first_name'].'_'. $app_data['last_name'].'_cv'. '.'. $ext;
				if (!is_uploaded_file($_FILES['cv_file']['tmp_name']) or !copy($_FILES['cv_file']['tmp_name'], $filename)){
					$error_msg['cv_file']['error_msg'] = "Could not  save file as $filename! -- Error Code :".$_FILES['cv_file']['error'];
					log_message('error','File upload error: '.$error_msg['cv_file']['error_msg']);
				}else{
					$app_data['cv_path'] = $filename;
				}
			}else{
				$error_msg[] = array('type'=>'error','msg'=> 'The CV you have uploaded is incompatible. Please upload a pdf,doc,docx or txt file!');
			}//end if
		}//endif
	
		if(empty($error_msg)){
			$this->new_duplicate_entry_check($app_data,$wrapper,$post_proffe_data,$post_academic_data,$post_exper_data);
		}else{
			$wrapper['msg']= $error_msg;
			$this->load->view('new_apply_now',$wrapper);
		}//end if error msg check
	}//end of function
	
	
	
	function duplicate_entry_check($app_data,$wrapper){		
		foreach($app_data as $c=>$v){
			if($c!='mode' && $c!='formstatus' && $c !='MAX_FILE_SIZE' ){
				if($c=='post_id'|| $c=='first_name' || $c=='last_name' || $c=='gender' || $c=='date_of_birth' || $c=='email' && $c=='mobile_phone' || $c=='nic_pp_no'){
					$dup_data[$c]=$v;
				}
			}
		}
		
		$dup_data['app_date'] = $wrapper['app_date'];
		$dup_validation = $this->job_applications_model->exists($dup_data);
		
		if(empty($dup_validation)){
			$this->has_applied_within_months_range($app_data,$wrapper);
		}else{
			$wrapper['msg'][]= array('type'=>'error','msg'=>'You cannot apply for same job post more than once!');
			$this->load->view('apply_now',$wrapper);
		}
	}//end of function
	


	function new_duplicate_entry_check($app_data,$wrapper,$post_proffe_data,$post_academic_data,$post_exper_data){
		foreach($app_data as $c=>$v){
			if($c!='mode' && $c!='formstatus' && $c !='MAX_FILE_SIZE' ){
				if($c=='post_id'|| $c=='first_name' || $c=='last_name' || $c=='gender' || $c=='date_of_birth' || $c=='email' && $c=='mobile_phone' || $c=='nic_pp_no'){
					$dup_data[$c]=$v;
				}
			}
		}
	
		$dup_data['app_date'] = $wrapper['app_date'];
		$dup_validation = $this->job_applications_model->exists($dup_data);
	
		if(empty($dup_validation)){
			$this->new_has_applied_within_months_range($app_data,$wrapper,$post_proffe_data,$post_academic_data,$post_exper_data);
		}else{
			$wrapper['msg'][]= array('type'=>'error','msg'=>'You cannot apply for same job post more than once!');
			$this->load->view('new_apply_now',$wrapper);
		}
	}//end of function
	
	
	
	function has_applied_within_months_range($app_data,$wrapper){
		$previous_app_submit_date = null;
		$settings_dataset = $this->settings_model->get_data(
			array(
				'search'=> array(array('search_field' => 'section', 'search_text' => 'applications section', 'query_method'=>'equal')),
				'limit'=>1, 'offset'=>0, 'order_by'=>array('settings.id'=>'Asc')
			)
		);
		
		$settings_json = $settings_dataset['result_set'][1]['settings_json'];
		$settings = json_decode($settings_json,true);
		$re_apply_duration = $settings['re_apply_period'];
		
		$searchobj_array = array();
		$new_application_submit_date = $wrapper['app_date'];
		
		foreach($app_data as $c=>$v){
			if($c!='mode' && $c!='formstatus' && $c !='MAX_FILE_SIZE' ){
				if($c=='post_id'|| $c=='first_name' || $c=='last_name' || $c=='gender' || $c=='date_of_birth' || $c=='email' || $c=='nic_pp_no'){
					$search_obj= array('search_field' => $c, 'search_text' => $v,'query_method'=>'equal');
					array_push($searchobj_array, $search_obj);
				}
			}
		}
		
		$result = $this->job_applications_model->get_data(
			array(
				'search'=>$searchobj_array,
				'limit' => 1, 'offset'=> 0,
				'order_by'=>array('job_applications.id'=>'desc')
			)
		);
		
		if(!empty($result['result_set'])){
			//fetch application submission date
			$previous_app_submit_date = $result['result_set'][1]['app_date'];
			$previous_app_submit_date = rtrim($previous_app_submit_date,'00:00:00');
		}
		
		$date1 = $previous_app_submit_date;
		$date2 = $new_application_submit_date;
	
		$ts1 = strtotime($date1);
		$ts2 = strtotime($date2);
		
		$year1 = date('Y', $ts1);
		$year2 = date('Y', $ts2);
		
		$month1 = date('m', $ts1);
		$month2 = date('m', $ts2);
		
		$diff = (($year2 - $year1) * 12) + ($month2 - $month1);
		
		if($diff >= $re_apply_duration){
			$this->evaluate_application($app_data,$wrapper);
		}else{
			$wrapper['msg'][]= array('type'=>'error','msg'=>"You have already applied for this job $diff months ago. Please re apply after $re_apply_duration months from your first application.");
			
			//send reject mail
			$subject = "Reject Application";
			$msg = "You have already applied for this job $diff months ago. Please re apply after $re_apply_duration months from your first application.";
			$to = $wrapper['email'];
			email_send($subject, $msg, $to='');
			
			$this->load->view('apply_now',$wrapper);
		}
	}//end of function


	function new_has_applied_within_months_range($app_data,$wrapper,$post_proffe_data,$post_academic_data,$post_exper_data){
		$previous_app_submit_date = null;
		$settings_dataset = $this->settings_model->get_data(
				array(
						'search'=> array(array('search_field' => 'section', 'search_text' => 'applications section', 'query_method'=>'equal')),
						'limit'=>1, 'offset'=>0, 'order_by'=>array('settings.id'=>'Asc')
				)
		);
	
		$settings_json = $settings_dataset['result_set'][1]['settings_json'];
		$settings = json_decode($settings_json,true);
		$re_apply_duration = $settings['re_apply_period'];
	
		$searchobj_array = array();
		$new_application_submit_date = $wrapper['app_date'];
	
		foreach($app_data as $c=>$v){
			if($c!='mode' && $c!='formstatus' && $c !='MAX_FILE_SIZE' ){
				if($c=='post_id'|| $c=='first_name' || $c=='last_name' || $c=='gender' || $c=='date_of_birth' || $c=='email' || $c=='nic_pp_no'){
					$search_obj= array('search_field' => $c, 'search_text' => $v,'query_method'=>'equal');
					array_push($searchobj_array, $search_obj);
				}
			}
		}
	
		$result = $this->job_applications_model->get_data(
				array(
						'search'=>$searchobj_array,
						'limit' => 1, 'offset'=> 0,
						'order_by'=>array('job_applications.id'=>'desc')
				)
		);
	
		if(!empty($result['result_set'])){
			//fetch application submission date
			$previous_app_submit_date = $result['result_set'][1]['app_date'];
			$previous_app_submit_date = rtrim($previous_app_submit_date,'00:00:00');
		}
	
		$date1 = $previous_app_submit_date;
		$date2 = $new_application_submit_date;
	
		$ts1 = strtotime($date1);
		$ts2 = strtotime($date2);
	
		$year1 = date('Y', $ts1);
		$year2 = date('Y', $ts2);
	
		$month1 = date('m', $ts1);
		$month2 = date('m', $ts2);
	
		$diff = (($year2 - $year1) * 12) + ($month2 - $month1);
	
		if($diff >= $re_apply_duration){
			$this->new_evaluate_application($app_data,$wrapper,$post_proffe_data,$post_academic_data,$post_exper_data);
		}else{
			$wrapper['msg'][]= array('type'=>'error','msg'=>"You have already applied for this job $diff months ago. Please re apply after $re_apply_duration months from your first application.");
				
			//send reject mail
			$subject = "Reject Application";
			$msg = "You have already applied for this job $diff months ago. Please re apply after $re_apply_duration months from your first application.";
			$to = $wrapper['email'];
			email_send($subject, $msg, $to='');
				
			$this->load->view('new_apply_now',$wrapper);
		}
	}//end of function
	
	
	
	function evaluate_application($app_data,$wrapper){
		$required_array = array();
		$app_data['status']='NEW';
		
		$fields_array = array('have_adsl',"plan2getadsl","has_own_computer","can_wok_min","canwork_8hrs","cantwork_8hrs",
			"wfh_ok","why_wfh","has_other_job","other_job_des","is_studying","study_details","room2work","minsalexp","whyhire"
		);
		
		//check if same application details are found in applications table within given month range
		foreach($app_data as $c=>$v){
			if($c!='mode' && $c!='formstatus' && $c !='MAX_FILE_SIZE' ){
				if(in_array($c,$fields_array)){
					$required_array[$c] = $v;
				}
			}
		}
		
		if($required_array['have_adsl']=='None'){
			if($required_array['plan2getadsl'] == 'No'){
				$app_data['status']='REJECTED';
			}
		}
		if($required_array['has_own_computer']=='No'){
			$app_data['status']='REJECTED';
		}
		if($required_array['can_wok_min']=='No'){
			$app_data['status']='REJECTED';
		}
		if( $required_array['canwork_8hrs']=='No'){
			//$app_data['status']='REJECTED';
		}
		if($required_array['wfh_ok']=='No'){
			$app_data['status']='REJECTED';
		}
		if($required_array['room2work']=='No'){
			$app_data['status']='REJECTED';
		}
		$this->save_application_data($app_data,$wrapper);
	}//end of function
	
	function new_evaluate_application($app_data,$wrapper,$post_proffe_data,$post_academic_data,$post_exper_data){
		$required_array = array();
		$app_data['status']='NEW';
	
		$fields_array = array('have_adsl',"plan2getadsl","has_own_computer","can_wok_min","canwork_8hrs","cantwork_8hrs",
				"wfh_ok","why_wfh","has_other_job","other_job_des","is_studying","study_details","room2work","minsalexp","whyhire"
		);
	
		//check if same application details are found in applications table within given month range
		foreach($app_data as $c=>$v){
			if($c!='mode' && $c!='formstatus' && $c !='MAX_FILE_SIZE' ){
				if(in_array($c,$fields_array)){
					$required_array[$c] = $v;
				}
			}
		}
	
		if($required_array['have_adsl']=='None'){
			if($required_array['plan2getadsl'] == 'No'){
				$app_data['status']='REJECTED';
			}
		}
		if($required_array['has_own_computer']=='No'){
			$app_data['status']='REJECTED';
		}
		
		if($required_array['wfh_ok']=='No'){
			$app_data['status']='REJECTED';
		}
		if($required_array['room2work']=='No'){
			$app_data['status']='REJECTED';
		}
		$this->new_save_application_data($app_data,$wrapper,$post_proffe_data,$post_academic_data,$post_exper_data);
	}//end of function
	
	function save_application_data($app_data,$wrapper){
		$app_data['app_date'] = $app_data['app_date'];
		$dup_validation = $this->job_applications_model->exists($app_data);
		
		if(empty($dup_validation)){
			$this->job_applications_model->save($app_data,false);
			$wrapper['msg'][] = array('type'=>'success' , 'msg'=>'Your application has been submitted successfully!');
			
			//sending mail to person who assign for new_app_alert
			$this->load->model('Job_definitions_model');
			$job_definitions_data = $this->Job_definitions_model->get_data(array(
				'search'=>array(array('search_field'=>'id', 'search_text'=>$app_data['post_id'], 'query_method'=>'equal')),
				'limit'=>0,'offset'=>0
			));
			$job_definitions_data = $job_definitions_data['result_set'][1];
			$subject = "New Application Alert";
			$msg = "Dear Staff,<br/><br/>";
			$msg .= "This is to inform you that New Application added to HRM system for ".$job_definitions_data['designation'];
			$msg .= " by ".$app_data['first_name']." ".$app_data['last_name']."<br/><br/>";
			$msg .= 'Please check HRM system "Applications" for further details.';
			$msg .= "<br/><br/>Thank you.<br/><br/>PDA Team.";
			$to = $job_definitions_data['new_app_alert'];
			email_send($subject,$msg,$to);
			
			
			if(!empty($app_data['profile_ok']) && $app_data['profile_ok'] == 'Yes'){
				$this->create_profile_page($app_data,$wrapper);
			}
			$this->load->view('after_submit',$wrapper);
		}else{
			$wrapper['msg'][]= array('type'=>'error','msg'=>"Your application has been submitted already");
			$this->load->view('apply_now',$wrapper);
		}//end if
	}//end of function
	

	function new_save_application_data($app_data,$wrapper,$post_proffe_data,$post_academic_data,$post_exper_data){
		$app_data['app_date'] = $app_data['app_date'];
		$dup_validation = $this->job_applications_model->exists($app_data);
	
		if(empty($dup_validation)){
			$this->job_applications_model->save($app_data,false);
			$app_id = $this->db->insert_id();
			$wrapper['msg'][] = array('type'=>'success' , 'msg'=>'Your application has been submitted successfully!');
			
				//Save professional Qualifications
				if(!empty($post_proffe_data)){
				foreach($post_proffe_data as  $prof_value) {
					$q_data2save_prof['profe_school_attended']=$prof_value['profe_school_attended'];
					$q_data2save_prof['profe_school_year'] =$prof_value['profe_school_year'];
					$q_data2save_prof['profe_school_achivement'] =$prof_value['profe_school_achivement'];
					$q_data2save_prof['application_id'] = $app_id;
					$ipq_key2save = array('id' => null);
					$proffe_data= $this->Professional_qualifications_model->save($q_data2save_prof,$ipq_key2save);
				}
				}			
				//Save Academic Qualifications
				if(!empty($post_academic_data)){
				foreach($post_academic_data as  $acade_value) {
					$q_data2save_acade['academic_school_attended']=$acade_value['academic_school_attended'];
					$q_data2save_acade['academic_school_year'] =$acade_value['academic_school_year'];
					$q_data2save_acade['academic_school_achivement'] =$acade_value['academic_school_achivement'];
					$q_data2save_acade['application_id'] = $app_id;
					$accipq_key2save = array('id' => null);
					$academic_data = $this->Academic_qualifications_model->save($q_data2save_acade,$accipq_key2save);
				}
				}
				//Save Work Experience
				if(!empty($post_exper_data)){
				foreach($post_exper_data as  $expe_value) {
					$q_data2save_expe['experience_company_name']=$expe_value['experience_company_name'];
					$q_data2save_expe['experience_designation'] =$expe_value['experience_designation'];
					$q_data2save_expe['experience_duration'] =$expe_value['experience_duration'];
					$q_data2save_expe['experience_reason_for_leave'] =$expe_value['experience_reason_for_leave'];
					$q_data2save_expe['application_id'] = $app_id;
					$exipq_key2save = array('id' => null);
					$experinece_data = $this->Work_experience_model->save($q_data2save_expe,$exipq_key2save);
				}
			 }
			//sending mail to person who assign for new_app_alert
			$this->load->model('Job_definitions_model');
			$job_definitions_data = $this->Job_definitions_model->get_data(array(
					'search'=>array(array('search_field'=>'id', 'search_text'=>$app_data['post_id'], 'query_method'=>'equal')),
					'limit'=>0,'offset'=>0
			));
			$job_definitions_data = $job_definitions_data['result_set'][1];
			$subject = "New Application Alert";
			$msg = "Dear Staff,<br/><br/>";
			$msg .= "This is to inform you that New Application added to HRM system for ".$job_definitions_data['designation'];
			$msg .= " by ".$app_data['first_name']." ".$app_data['last_name']."<br/><br/>";
			$msg .= 'Please check HRM system "Applications" for further details.';
			$msg .= "<br/><br/>Thank you.<br/><br/>PDA Team.";
			$to = $job_definitions_data['new_app_alert'];
			email_send($subject,$msg,$to);
				
				
			//if(!empty($app_data['profile_ok']) && $app_data['profile_ok'] == 'Yes'){//TSJ
				$this->create_profile_page($app_data,$wrapper);
			//}  // TSJ
			
			
			$this->load->view('after_submit',$wrapper);
		}else{
			$wrapper['msg'][]= array('type'=>'error','msg'=>"Your application has been submitted already");
			$this->load->view('new_apply_now',$wrapper);
		}//end if
	}//end of function
		
	/**
	 * Function  create_profile_page ()
	 *	
	 * This function creates profiels for applicants who are agreed at the time of submitting their first application for a job post.
	 * This will create profile page and then sends out emails with auto generated passwords
	 *
	 * @param array $app_data
	 * @param array $wrapper
	 * @access protected
	 * @since 
	 * @modified           Jun 13, 2016 by Roshan
	 * @modification       
	 * @return void
	 */
	function create_profile_page($app_data,$wrapper){
		$dup_check = null;
		foreach($app_data as $c=>$v){
			$fields_array = array('mode','formstatus','MAX_FILE_SIZE','post_id','reason_4_leave',
				'have_adsl','plan2getadsl', 'has_own_computer', 'can_wok_min',
				'canwork_8hrs', 'cantwork_8hrs', 'wfh_ok', 'why_wfh', 'has_other_job',
				'other_job_des', 'is_studying', 'study_details', 'room2work', 'minsalexp',
				'whyhire', 'test_time_a', 'test_time_b', 'how_u_heard', 'profile_ok','app_date'
			);
			if(!in_array($c,$fields_array)){
				$profiledata[$c] = $v;
				$dup_check[$c] = $v;
			}
		}
		
		unset($dup_check['app_date']);
		unset($dup_check['created_date']);
		unset($dup_check['status']);
		
		$dup_validation = $this->profiles_model->exists($dup_check);
		if(empty($dup_validation)){
			$profiledata['status'] = 'active';
			$profiledata['created_date'] = $wrapper['app_date'];
			
			//prepare One Time Password
			$string = 'abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
			$string_shuffled = str_shuffle($string);
			$password = substr($string_shuffled, 1, 7);
			$profiledata['password'] = md5($password);
			$this->profiles_model->save($profiledata,false);
			//get email settings from settings table
			
			$settings_dataset = $this->settings_model->get_data(
				array(
					'search'=> array(array('search_field' => 'section', 'search_text' => 'applications section', 'query_method'=>'equal')),
					'limit' => 1, 'offset'=>0, 'order_by'=>array('settings.id'=>'Asc')
				)
			);
			
			$settings_json = $settings_dataset['result_set'][1]['settings_json'];
			$settings = json_decode($settings_json,true);
			$default_email_template = "Dear ".$app_data['first_name'].',<br><br>'.
				'Your profile has been created at Ekwa jobs board.<br>
				Your login credentials are as follows,<br><br>'.
				'User id: '.$app_data['email'].'<br>'.
				'Password: '.$password.
				'<br><br>Please login to your profile page and change your password by clicking on following link,<br><br>'.
				'<a href="'.site_url('profiles/index').'">'.site_url('profiles/index').'</a><br><br>'.
				'Thank You,<br>Ekwa Job Board';
			
			$subject = !empty($settings['profile_email_subject']) ? $settings['profile_email_subject']:'Your profile has been created at Ekwa';
			$email_template = (!empty($settings['profile_email_template']))?$settings['profile_email_template']:$default_email_template;
			
			//replace name
			$email_template = str_replace('@@APPLICANT_FULL_NAME@@',$app_data['title'].' '.$app_data['first_name'].' '.$app_data['last_name'],$email_template);
			
			//replace userid
			$email_template = str_replace('@@USERID@@',$app_data['email'],$email_template);
			
			//replace password
			$email_template = str_replace('@@PASSWORD@@',$password,$email_template);
			
			//replace profile url
			$email_template = str_replace('@@PROFILE_URL@@','<a href="'.site_url('profiles/index').'">'.site_url('profiles/index').'</a>',$email_template);
			
			email_send($subject,$email_template,$app_data['email']);
		}//end of dup validation
	}//end of function
	

	
	
		
	
	/**
	 * Function save()
	 * 
	 * 
	 * Data from View
	 * using $_REQUEST
	 * Data to model
	 * send data as a array
	 * two arrays. One is for data and one is for key.
	 * ex: data=array('field1'=>'value1','field2'=>'value2'.....);
	 *     key=array('staff_id'=>123,'project_id'=>534);
	 *     
	 * @param   action - add or edit
	 * @param   callback - callback fun name for field validation
	 * @return  bool true/false
	 * @access	
 	 * @since	2.0
	 */
	     
  	function save($action,$callback = null){
  		$save_data=array();
  		$key=array();
  		$metadata = $this->job_applications_model->getMetadata();
  		$metadata = explode(",",$metadata['PK']);
  		log_message('info','Save data :-'.serialize($_POST));
  		
  		foreach((count($_POST)>0?$_POST:$_GET) as $k => $v){
  			$end = substr(strrchr($k, "_"), 1);
  			if(in_array($k,$metadata) !== false) {
  				$key[$k] = $v;
  			}elseif($end=='skip') {
  				//nothing do with skip
  			}else {
  				$save_data[$k]=$v;
  			}
  		}
  		
  		// AIR call handling mechanism ============================================================================
  		// if AIR_call_flag is true which means its an AIR related call/external call
  		//if($this->AIR_call_flag){
  			//if($this->debug)log_message('info',"save() invoked: request method:".$this->AR_Utilities->request_method);

  			//** Implement AIR call variable validation as following example code. Use error codes above 520  			
  			/*  			    
  			if(empty($actual_start_date)){
  				$this->AR_Utilities->header_output(520,'Actual Start Date cannot be empty');
  				exit;
  			}else if(empty($actual_end_date)){
  				$this->AR_Utilities->header_output(521,'Actual End Date cannot be empty');
  				exit;
  			}
  			*/  			  			
  			//if($this->AR_Utilities->request_method == 'get'){
  				// usually form submissions are made as post. If your form submits as get then use this 
  				// space to echo output as notmal or use a view file whenever appropriate
  			//}else if($this->AR_Utilities->request_method == 'post'){  			
  			//	$added=$this->job_applications_model->save($save_data,$key);  				
  			//	$this->log_create->set_otherDetails(array('Mode'=>$action,'AIR call: Data'=>serialize($save_data).", KEY: ".serialize($key)));
  			//	$this->log_create->init();  				
  			//	$this->AR_Utilities->header_output(200,$added); // You can customized your success message as you wish  				
  			//}	
  			//end if AIR call verifier		
  		//}else{  				
			$added=$this->job_applications_model->save($save_data,$key);
			$this->log_create->set_otherDetails(array('Mode'=>$action,'Data'=>serialize($save_data).", KEY: ".serialize($key)));
			$this->log_create->init();  	 			
			echo $added;  	
  		//}
  		//=====================================================================================================================		
	}//end of save method
	    
	
	function update_status($status=null,$id_list=null){
		$this->log_create->set_otherDetails(array('Mode'=>'Update_status','Data'=>$_POST?serialize($this->input->post()):("$status,$id_list")));
		$this->log_create->init();
		
		switch($status){
			case 'shortlistall':
				$ids = explode('-',$id_list);
				
				foreach($ids as $id){
					if(!empty($id))
					$this->job_applications_model->save(array('status'=>'SHORTLISTED','stat_cng_date'=> date("Y-m-d H:i:s")),array('id'=>$id));
					
					$job_def_data = $this->Job_definitions_model->get_data(array(
						'search'=>array(array('search_field'=>'id', 'search_text'=>$id, 'query_method'=>'equal')),
						'limit'=>0,'offset'=>0
					));
					foreach ($job_def_data['result_set'] as $key=>$values){
						$subject = "Application for Interview";
						$msg = "Dear Staff,<br/><br/>";
						$msg .= "This is to inform you that PDA shortlist application applied to ".$values['designation'];
						$msg .= " Please login to HRM system and process interview arraignment<br/><br/>";
						$msg .= "<br/><br/>Thank you.<br/><br/>PDA Team.";
						$to = $values['intviw_alert'];
						email_send($subject,$msg,$to);
					}
				}
				echo 1;
			break;
			case 'rejectall':
				$ids = explode('-',$id_list);
				foreach($ids as $id){
					if(!empty($id))
						$this->job_applications_model->save(array('status'=>'REJECTED','stat_cng_date'=> date("Y-m-d H:i:s")),array('id'=>$id));
				}
				echo 1;
			break;
			case 'waitlistall':
				$ids = explode('-',$id_list);
				foreach($ids as $id){
					if(!empty($id))
						$this->job_applications_model->save(array('status'=>'WAITLISTED','stat_cng_date'=> date("Y-m-d H:i:s")),array('id'=>$id));
				}
				echo 1;
			break;
			case 'reject':
				$this->job_applications_model->save(array('status'=>'REJECTED','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
				echo 1;
			break;
			case 'waitlist':
				$this->job_applications_model->save(array('status'=>'WAITLISTED','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
				echo 1;
			break;
			
			case 'interview_scheduled':
				$this->job_applications_model->save(array('status'=>'INTERVIEW SCHEDULED','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
				echo 1;
			break;
			case 'interview_done':
				$this->job_applications_model->save(array('status'=>'INTERVIEW DONE','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
				echo 1;
			break;
			case 'test_given':
				$this->job_applications_model->save(array('status'=>'TEST GIVEN','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
				echo 1;
			break;
			case 'test_done':
				$this->job_applications_model->save(array('status'=>'TEST DONE','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
				echo 1;
			break;
			case 'evaluation_done':
				$this->job_applications_model->save(array('status'=>'EVALUATION DONE','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
				echo 1;
			break;
			case 'offer_letter':
				$this->job_applications_model->save(array('status'=>'SEND LETTER','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
				echo 1;
			break;
			case 'offer_submitted':
				$this->job_applications_model->save(array('status'=>'OFFER SUBMITTED','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
				echo 1;
			break;
			case 'review_letter':
				$this->job_applications_model->save(array('status'=>'REVIEW LETTER','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
				echo 1;
			break;
			case 'hire_app':
				$this->job_applications_model->save(array('status'=>'HIRED','stat_cng_date'=>date("Y-m-d H:i:s")),array('id'=>$id_list));
			break;
		}
	}//end of function
	    
	/**
	 * Function key_validate()
	 * 
	 *
	 * This is to validate the keys which are send based on the action param
	 * key=array('staff_id'=>123,'project_id'=>534,'worktype_id'=>342);
	 *
	 * @param $action , add / edit
	 * @param $key , primary $key can be composit or single
	 * @return true on success or on valid key , on inexistance or invalid key error will be returned as an array
	 * 		ex: array('primary_key'=>'Doesnt exists','staff_id'=>'Doesnt exists')
	 * @access
	 * @since	2.0
	 */
    function key_validate($action,$key) {
	    //make overall validation true at the begining
	    $overall_valid=true;
	    $error_info=array();
	    
	    /*check for the primary key or composite key exists. Send key array to check.*/
	    $key_exist=$this->job_applications_model->exists($key);
		
	    if($key_exist) {
	      if($action=='add') {
	          //if the primary key exists this can not add. so validation fails and add information 
	          //to error info array.
	          $overall_valid=false;
	          $error_info['primary_key']='Record Already exists';
	      }
	      if($action=='edit') {
	          //in edit function the primary key should be there.
	          //to error info array.
	          $overall_valid=true;
	      }
	    }else {
	      if($action=='add') {
	          //if primary key not found it can be added
	          $overall_valid=true;                   
	      }
	      if($action=='edit') {
	          //if primary key not found it can not be edited         
	          $overall_valid=false;
	          $error_info['primary_key']='Record Doesnt exists';
	      }
	    }
	      
	    if($overall_valid==true){
	        return true;
	    }
	    else  {
	        return $error_info; //array('primary_key'=>'Already exists') or
	                            //array('primary_key'=>'Doesnt exists','staff_id'=>'Doesnt exists')  
	    }
    }
 	
    
	/**
	 * Function delete()
	 * 
	 * 
	 * Data from View
	 * using $_REQUEST
	 * $_REQUEST['staff_id']=234
	 *
	 * @param $String, the key 
	 * 		Data to model
	 * 		send a array
	 * 		ex: $key = array('staff_id'=>123,'project_id'=>245,'worktype_id'=>933)
	 * @return 
     * @access	
     * @since	2.0
	 */
	function delete($String){
		$delete = array();
		
		$delete['id'] = $String;
		$this->log_create->set_otherDetails(array('Mode'=>'delete','Data'=>serialize($delete)));
		$this->log_create->init();
		return($this->job_applications_model->delete($delete));
	}
 	
	
	/**
	 * Function loadForm()
	 * 
	 * 
	 * load the form for creation / edit
	 * 
	 * @param $editable, key, mode info
	 * @param $file , name of the view file
	 * @return 
     * @access	
     * @since	2.0
	 */ 
  	function loadForm($editable=null,$file='job_applications_form') {
  		$data['editable'] = $editable;
  		$this->load->view($file,$data);
  	} 
	
  	
	 /**
	  * Function loadWB()
	  * 
	  * 
	  * function initiates the workbech
	  *
	  * @param $file , name of the view file
	  * @return loads the work bench
	  * @access	
	  * @since	2.0
	  */
	function loadWB($file='job_applications_wb'){
 		$data ='';
  		$this->load->view($file,$data);
  	}
  	
  	
  	function settings(){
  		$wrapper['message'] = array('msgType' => null, 'msgText' => null);
  		$wrapper['settings'] = $this->input->post(null,true);
  		
  		if(!empty($wrapper['settings']['re_apply_period'])){
  			unset($wrapper['settings']['csrf_user_form_token']);
  			$settings['section'] = 'applications section';
  			$settings['settings_json'] = json_encode($wrapper['settings']);
  			$this->settings_model->save($settings,array('section' => $settings['section']));
  			$wrapper['message'] = array('msgType' => 'success', 'msgText' => 'Application settings successfully updated!');
  		}//end if
  		
  		$dataset = $this->settings_model->get_data(
  			array(
  				'search'=> array(array('search_field' => 'section', 'search_text' => 'applications section', 'query_method'=>'equal')),
  				'limit' => 1, 'offset'=>0, 'order_by'=>array('settings.id'=>'Asc')
  			)
  		);
  		$wrapper['dataset'] = $dataset['result_set'];
  		$settings_parts = json_decode( $dataset['result_set'][1]['settings_json'],true);
  		
  		foreach($settings_parts as $key=>$val){
  			$wrapper[$key] = $val;  			
  		}
  		$wrapper['id'] = $dataset['result_set'][1]['id'];
  		$this->load->view('job_application_settings_form',$wrapper);
  	}//end of function
  	
  	
  	function get_settings(){
  		$wrapper['message'] = array('msgType' => null, 'msgText' => null);
  		$wrapper['settings'] = $this->input->post(null,true);
  	
  		if(!empty($wrapper['settings']['re_apply_period'])){
  			unset($wrapper['settings']['csrf_user_form_token']);
  			$settings['section'] = 'applications section';
  			$settings['settings_json'] = json_encode($wrapper['settings']);
  			$this->settings_model->save($settings,array('section' => $settings['section']));
  			$wrapper['message'] = array('msgType' => 'success', 'msgText' => 'Application settings successfully updated!');
  			echo "success";
  			
  		}//end if
  	
  		$dataset = $this->settings_model->get_data(
  				array(
  						'search'=> array(array('search_field' => 'section', 'search_text' => 'applications section', 'query_method'=>'equal')),
  						'limit' => 1, 'offset'=>0, 'order_by'=>array('settings.id'=>'Asc')
  				)
  		);
  		$wrapper['dataset'] = $dataset['result_set'];
  		$settings_parts = json_decode( $dataset['result_set'][1]['settings_json'],true);
  	
  		foreach($settings_parts as $key=>$val){
  			$wrapper[$key] = $val;
  		}
  		$wrapper['id'] = $dataset['result_set'][1]['id'];
  		$this->load->view('job_application_settings_form_apply',$wrapper);
  	}//end of function
  	
  	function save_settings(){
  		$wrapper['message'] = array('msgType' => null, 'msgText' => null);
  		$wrapper['settings'] = $this->input->post(null,true);
  		 
  		if(!empty($wrapper['settings']['re_apply_period'])){
  			unset($wrapper['settings']['csrf_user_form_token']);
  			$settings['section'] = 'applications section';
  			$settings['settings_json'] = json_encode($wrapper['settings']);
  			$this->settings_model->save($settings,array('section' => $settings['section']));
  			$wrapper['message'] = array('msgType' => 'success', 'msgText' => 'Application settings successfully updated!');
  			echo "success";
  				
  		}//end if
  		 
  		$dataset = $this->settings_model->get_data(
  				array(
  						'search'=> array(array('search_field' => 'section', 'search_text' => 'applications section', 'query_method'=>'equal')),
  						'limit' => 1, 'offset'=>0, 'order_by'=>array('settings.id'=>'Asc')
  				)
  		);
  		$wrapper['dataset'] = $dataset['result_set'];
  		$settings_parts = json_decode( $dataset['result_set'][1]['settings_json'],true);
  		 
  		foreach($settings_parts as $key=>$val){
  			$wrapper[$key] = $val;
  		}
  		$wrapper['id'] = $dataset['result_set'][1]['id'];
  		//$this->load->view('job_application_settings_form_apply',$wrapper);
  	}//end of function
  	
	    /**
 		 * Function createDropdown()
 		 *
 		 * 
 		 * Function overview :-
 		 * createDropdown is the component function. 
 		 * Its main functionality is to produce a dropdown with pre populated table data
 		 *
 		 * Parameter list :-
 		 *
 		 *   $data['displayClm']     => 'field1'  - preselection of column to be displayed         //sachini
 		 *   $data['selectByValue']  => null      - preselection of list items by value
 		 *   $data['selectBYText']   => null      - preselection of list items by Text
 		 *   $data['filterBy']       => null      - filter data set by a field or list
 		 *   $data['outFormat']      => 'html'    - Format of the output like HTML,XML Etc
 		 *   $data['isMultiple']     => false     - is the drop down with multi select capable
 		 *   $data['sort']           => 'asc'     - sort list text Ascending or Descending
 		 *   $data['optionsOnly']    => false     - Specify the controller that output only <options> values
 		 *   $data['groupBy']        => null      - Display the dropdown grouped according to the specified column        //sachini
 		 *   $data['nameTag']        => 'field2'  - Name and Id values of the select tag                                 //sachini
 		 *
 		 *    Usage :-
 		 *
 		 *    1) Format for internal functional call by passing data array
 		 *    $data = array('selectByValue' => null,
 		 *					'selectBYText' => null,
 		 *					'outFormat' => 'html' ,
 		 *					'isMultiple' => false,
 		 *					'sort' => 'asc',
 		 *					'optionsOnly' => false,
 		 *					'filterBy' => array(
 		 *									'search_field' => 'T.status',
 		 *									'search_text' => '0',
 		 *									'query_method'=>'equal',
 		 *									'order_by' => 'asc'
 		 *									)
 		 *						)
 		 *
 		 *    2) Format of external call by URL
 		 *    http://.../index.php/Job_applications/createDropdown/?sbv=null&sbt=null&format=html&multiple=false&sort=asc&filterby=status_equal=1
 		 *
 		 *    1. For normal listing:
 		 *    http://.../index.php/Job_applications/createDropdown
 		 *
 		 *    2. For listing with multiple selection
 		 *    http://.../index.php/Job_applications/createDropdown/?multiple=true
 		 *
 		 *    3. For listing with pre selection (select by value) for single selection drop down
 		 *    http://.../index.php/Job_applications/createDropdown/?sbv=123
 		 *
 		 *    4. For listing with pre selection for multiple (select by value)
 		 *    http://.../index.php/Job_applications/createDropdown/?sbv=123,321,345&multiple=true
 		 *
 		 *    5. For listing with pre selection of select by text for single selection dropdown
 		 *     http://.../index.php/Job_applications/createDropdown/?sbt=test string&multiple=true
 		 *
 		 *    6. For xml(DHTMLX compatible) dropdown
 		 *    http://.../index.php/Job_applications/createDropdown/?format=xml
 		 *
 		 *    7. groupBy
 		 *    http://...../Job_applications/createDropdown/?groupby=users.user_type
 		 *
 		 *	 8. groupCode
 		 *	  http://..../Job_applications/createDropdown/?groupby=users.user_type&groupcodes=1=Staff,2=Admin,4=Manager
 		 *
 		 *    Description of parameter list,
 		 *
 		 *    sbv - selectByValue  => null
 		 *    sbt - selectBYText   => null
 		 *    format - outFormat   => 'html'
 		 *    multiple - isMultiple=> false
 		 *    sort - sort          => 'asc'
 		 *    filterby - filterBy  => null
 		 *    optionsOnly - options only listing
 		 *    groupBy - column to group, should be specified with the table name ex: job_applications.staff_id
 		 *	  groupcodes - coma seperated values to display as group lable
 		 *
		 * @param $data , data array
		 * @access public
		 * @return returns the table dropdown
		 * @since 1.0
 		 */
	public function createDropdown($data = false){
	  	$dataset = null;
	  	$selectByValue = null;
	  	$selectBYText = null;
	  	$outFormat = 'html' ;
	  	$isMultiple = null;
	  	$sort = null;
	    $sort_array = array('job_applications.id' => 'DESC');
	  	$filterBy = null;
	   	$searchobj_array = null;
	   	$optionsOnly = false;
	   	$label = null;
	   	$displayClm = 'job_applications.first_name';
	   	$groupBy = null;   
	   	$groupcodes = null;
	   	$nameTag = 'id'; 
	  	
		  	/**
		  	 *	first check whether the call is internal(ie:internal function call) or external(ie:url call)
		  	 *	to do this we can check $data variable.if this variable is an array it means its an internal call
		  	 *	if $data is 'false' it means its an external call.
		  	 */	
	  	if(is_array($data)){
	  		
	  		/** 
	  		 * this is an internal call. so construct the search obj with passed array parameeters. 
	  		 * extract the data and pass on to the view
	  		 */
	  		$selectByValue = isset($data['selectByValue'])?$data['selectByValue']:null;
	  		$selectBYText = isset($data['selectBYText'])?$data['selectBYText']:null;
	  		$outFormat = isset($data['outFormat'])?$data['outFormat']:null;
	  		$isMultiple = isset($data['isMultiple'])?$data['isMultiple']:false;
	  		$sort = isset($data['sort'])?$data['sort']:'job_applications.id=ASC';
	  		$filterBy = isset($data['filterBy'])?$data['filterBy']:null;
	  		$optionsOnly = isset($data['optionsOnly'])?$data['optionsOnly']:false;
	  		
	  		$label = isset($data['label'])?$data['label']:'id';
	  		$displayClm = isset($data['display'])?$data['display']:$displayClm;
	  		$groupBy = isset($data['groupBy'])?$data['groupBy']:null;    
	  		$nameTag = isset($data['nameTag'])?$data['nameTag']:'id';    
	  		$groupcodes = isset($data['groupcodes'])?$data['groupcodes']:null;
	  	}else{
	  		
	  		/** 
	  		 * this is an external url call. So process $_GET or $_POST parameeter values and using
	  		 * these values construct search obj and fetch data for combo box
	  		 */
	  		if(count($_POST)>0 || count($_GET)>0){
	  			
	        	$myParams = count($_POST)>0? $_POST:$_GET;
	  
	  			$selectByValue = isset($myParams['sbv'])? $myParams['sbv']:null ;		
	  			$selectByValue = (!empty($selectByValue))?$selectByValue:null; // set default values if not supplied.
	  			 		
	  			$selectBYText = isset($myParams['sbt'])?$myParams['sbt']:null;
	  			$selectBYText = (!empty($selectBYText))?$selectBYText:null;
	  			
	  			$outFormat = isset($myParams['format'])?$myParams['format']:null;
	  			$outFormat = ($outFormat != 'html' && !empty($outFormat))?$outFormat:'html';
	  			
	  			$isMultiple = isset($myParams['multiple'])?$myParams['multiple']:null;
	  			$isMultiple = ($isMultiple == 'true')?true:false;
	  			
	  			$sort = isset($myParams['sort'])?$myParams['sort']:'job_applications.id=ASC';
	  			
	  			$filterBy_string = isset($myParams['filterby'])? $myParams['filterby']:null;
	  			$filterBy_string = (!empty($filterBy_string))?$filterBy_string:null;
	  			
	  			$optionsOnly = isset($myParams['optionsonly'])? $myParams['optionsonly']:false;
	  			$optionsOnly = ($optionsOnly == 'true')? true:false;
	  
	  			$label = isset($myParams['label'])?$myParams['label']:null;
	  			$label = (!empty($label))?$label:null;
	  			
	  			$displayClm = isset($myParams['display'])? $myParams['display']:$displayClm;
	  			$displayClm = (!empty($displayClm))?$displayClm:'description';
	  			
	  			$groupBy = isset($myParams['groupby'])?$myParams['groupby']:null;    
	  			$groupBy = (!empty($groupBy))?$groupBy:null;                         
	  			
	  			$groupcodes = isset($myParams['groupcodes'])?$myParams['groupcodes']:null;
	  			
	  			/**
	  			 *	first check whether the request includes grouping
	  			 *	to do this we can check $groupBy variable.if this variable is null then it is ungrouped dropdown
	  			 *	if $groupBy is 'field1' it means its a request for grouped dropdown.
	  			 */
	  			if($groupBy){
	  				
	  				/**
	  				 * this is a grouped dropdown request
	  				 * set the $sort_array first sorted according to $groupBy column and then to $displayClm
	  				 */
	  				$sort_array = array($groupBy => 'ASC',$displayClm => 'ASC' );
	  				if (!empty($groupcodes)){
	  					$sortPara = explode(',',$groupcodes);
	  					foreach ($sortPara as $val ){
	  						$split =  explode('=',$val);
	  						$group[$split[0]]= $split[1];
	  					}
	  				}
	  			}else{
	  				
	  				/**
	  				 * this is not a grouped dropdown request
	  				 */
	  				$sort = isset($myParams['sort'])?$myParams['sort']:"$displayClm=ASC";
	  			}
	  			//end of sort allocation condition
	  			$nameTag = isset($myParams['nametag'])?$myParams['nametag']:$nameTag;   
	  			$nameTag = (!empty($nameTag))?$nameTag:'id';                       
	  			
	  			if(!empty($filterBy_string)){        
	  				$fieldPara = explode(',',$filterBy_string);
	          		foreach ($fieldPara as $val )   {
             			$split =  explode('=',$val);
             			$filterBy[$split[0]]= $split[1];
          			}
	  			}else{
	  				$filterBy = null;
	  			}
	        if (!empty($sort)){
	          $sortPara = explode(',',$sort);
	          foreach ($sortPara as $val )   {
	             $split =  explode('=',$val);
	             $sort_array[$split[0]]= $split[1];
	          }
	        }
	  		}
	  	}//end of param check and config
	  	// Construct search object if present 
	  		
	  	If ($filterBy){
	  		$searchobj_array = array();
	  		foreach($filterBy as $key => $val){
	  			$search_text = $val; //search text
	  			$query_method = substr(strrchr($key, "_"), 1);
	  			$pos = strrpos($key, '_');
	  			$field = substr($key, 0, $pos);
	  			$search_obj = array(
	  					'search_field' => $field,
	  					'search_text'  => $search_text,
	  					'query_method' => $query_method
	  			);
	  			array_push($searchobj_array, $search_obj);
	  		}	
	  	}//end if
	      //Construct selection list. (Fixed)
	      $selection = 'job_applications.id,job_applications.first_name,job_applications.last_name,job_applications.initials,job_applications.other_names,job_applications.address,job_applications.email,job_applications.land_phone,job_applications.mobile_phone,job_applications.primary_education_at,job_applications.primary_edu_qualy,job_applications.secondary_edu_at,job_applications.secondary_edu_qual,job_applications.professional_edu_at,job_applications.professional_edu_qual,job_applications.other_qual,job_applications.work_exp,job_applications.reason_4_leave,job_applications.cv,job_applications.have_adsl,job_applications.can_wok_min,job_applications.wfh_ok,job_applications.cv_path,job_applications.answer_path,job_applications.unsigned_offer_path,job_applications.signed_offer_path,job_applications.remarks,job_applications.status,job_applications.country,job_applications.post_id,job_applications.request_id,job_applications.app_date,job_applications.referrer_id,job_applications.title,job_applications.gender,job_applications.currency,job_applications.has_other_job,job_applications.other_job_des,job_applications.is_studying,job_applications.study_details,job_applications.canwork_8hrs,job_applications.cantwork_8hrs,job_applications.room2work,job_applications.minsalexp,job_applications.whyhire,job_applications.nic_pp_no,job_applications.date_of_birth,job_applications.civil_status,job_applications.has_own_computer,job_applications.plan2getadsl,job_applications.why_wfh,job_applications.test_time_a,job_applications.test_time_b,job_applications.how_u_heard,job_applications.extr_refs,job_applications.verified,job_applications.stat_cng_date,job_applications.offer_letter_tpl,job_applications.offer_letter_with_appdetails,job_applications.sent_offer_letter,job_applications.signed_offer_letter';
	    
	      // Fetch data from model
	  	  $dataset = $this->job_applications_model->get_data(array(
	  			'search' => $searchobj_array,
	  	  		'limit' => 0,
	  	  		'offset'=>0,
	  			'selection' => $selection,
	        		'order_by' => $sort_array));  
	  	
	  	  //joining first name and last name
		foreach ($dataset['result_set'] as $key=>$values){
	  	 	$full_name = $values['first_name']." ".$values['last_name'];
	  	 	$dataset['result_set'][$key]['first_name'] = ucfirst($full_name);
	  	}
	  	// Construct data structure for view
	  	$wrapped_data['data']['dataset'] = $dataset;	
	    $wrapped_data['selectByValue'] = $selectByValue;
	  	$wrapped_data['selectByText'] = $selectBYText;
	  	$wrapped_data['outFormat'] = $outFormat;
	  	$wrapped_data['isMultiple'] = $isMultiple;
	  	$wrapped_data['required'] = true;
		$wrapped_data['label'] = $label;
		
		$displayClm =  explode('.',$displayClm);
		$wrapped_data['display'] = $displayClm[1];
		$wrapped_data['nameTag'] = $nameTag;
	  	
	  	if($optionsOnly !=""){
	  		$wrapped_data['optionsOnly'] = $optionsOnly;
	  	}
	  	
	  	if($groupBy != ""){
	  		$gb_arrya=explode(",",$groupBy);
	  		for($x=0;$x<count($gb_arrya); $x++){
	  			$gb = explode(".",$gb_arrya[$x]);
	  			$wrapped_data['groupBy'] = $gb[1];
	  		}    
	  	}
	  	   
	  	if(!empty($group)){
	  		$wrapped_data['codename'] = $group;
	  	}
	  	
	  	//If AIR_call_flag is true which means its an AIR related call/external call=========================
	  //	if($this->AIR_call_flag){
	  		 
	  		// if the function call is from an external app then identify request method then
	  		// choose appropriate output mechanism.
	  		 
	  	//	if($this->debug) log_message('info',"createDropdown invoked via AIR call: QUERY- STRING :".count($_POST)>0?serialize($_POST):serialize($_GET));	  			
	  		//perform the function codes and call view file with output.
	  	//	if($this->AR_Utilities->request_method == 'get'){	  	
	  	//		$this->load->view('dropdown_template',$wrapped_data);	  	
	  	//	}else if($this->AR_Utilities->request_method == 'post'){	  	
	  			//If request method is post then use appropriate view files to output as post
	  			//...	  	
	  	//	}//end if method verifier	  	
	  	//}else{	  	
	  		// if the function call is from application itself then proceed with normal output.	  		
	  		// load view file with assigned data array
	  		$this->load->view('dropdown_template',$wrapped_data);	  		
	  	//}//end if air call validator	  	
	  	//End of AIR mechanism ==============================================================================	  	
	  		  	
    }// End of Function createDropdown
}//-------- END CLASS -------------------------------------------------------
?>