<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Google_Calendar_model extends CI_Model {
	public $google_calendar = null;
	
	function __construct(){
		parent::__construct();
		
		require APPPATH . "third_party/google-api-php-client/src/Google/autoload.php";
		
		$client_id = '108200369184872783393';
		//$Email_address = 'ekwa-hrm-calendar@ekwa-hrm.iam.gserviceaccount.com';	 
		//$key_file_location = APPPATH."config/HRM_Calendar-f5304980b06d.p12";
		
		$Email_address = 'hrm-testbeta@hrm-calendar.iam.gserviceaccount.com';
		$key_file_location = APPPATH."config/HRMCalendar-e7220cc82ff4.p12";
		
		$client = new Google_Client();	 	
		$client->setApplicationName("Client_Library_Examples");
		$key = file_get_contents($key_file_location);	 
		
		// separate additional scopes with a comma	 
		$scopes ="https://www.googleapis.com/auth/calendar.readonly"; 	
		$scope2 = "https://www.googleapis.com/auth/calendar";
		
		$cred = new Google_Auth_AssertionCredentials(	 
			$Email_address,	 	 
			array($scopes,$scope2),	 	
			$key	 	 
		);	 	
		$client->setAssertionCredentials($cred);
		if($client->getAuth()->isAccessTokenExpired()) {	 
			$client->getAuth()->refreshTokenWithAssertion($cred);	 	
		}	 	
		
		$this->google_calendar = new Google_Service_Calendar($client); 
	}//end of function


	public function view_calendar(){	
		//$data['calander_obj'] = $this->google_calendar;
		//$this->load->view('calendar_view',$data);
	}//end of function


	public function add_event($event_data){
		$data = array();

		//$calendarId='primary';
		$calendarId = 'g4gdq6d2ttjqd28acjiqe410l0@group.calendar.google.com';	
		
		if(!empty($event_data)){
			$event_data["start_date"]	= str_replace(" ","T",$event_data["start_date"]);
			$event_data["end_date"]		= str_replace(" ","T",$event_data["end_date"]);
			
			$data = array(
				'summary' 		=> $event_data['summary'],
				'start' 		=> $event_data["start_date"].'+05:30',
				'end' 			=> $event_data["end_date"].'+05:30',
				'description' 	=> $event_data['description'],
				'attendees'     => $event_data['attendees']
			);
	    	//date format is => 2016-06-18T17:00:00+03:00
			
	    	$event = new Google_Service_Calendar_Event(
				array( 
					'summary' => $data['summary'],
					'description' => $data['description'],
					'start' => array('dateTime' => $data['start'],'timeZone' => 'Asia/Colombo',),
					'end' => array('dateTime' => $data['end'], 'timeZone' => 'Asia/Colombo',),
					'attendees' => $data['attendees'],
	    			'reminders' => array(
					    'useDefault' => false,
					    'overrides' => array(
							array('method' => 'email', 'minutes' => 24 * 60),
							array('method' => 'popup', 'minutes' => 10),
						),
					),
				)
			);
	    	
	   		//var_dump($event_obj);
	   		/**
	   		object(Google_Service_Calendar_Event)#579 (52) { 
	   		["collection_key":protected]=> string(10) "recurrence" 
	   		["internal_gapi_mappings":protected]=> array(0) { } 
	   		["anyoneCanAddSelf"]=> NULL 
	   		["attachmentsType":protected]=> string(39) "Google_Service_Calendar_EventAttachment" 
	   		["attachmentsDataType":protected]=> string(5) "array" 
	   		["attendeesType":protected]=> string(37) "Google_Service_Calendar_EventAttendee" 
	   		["attendeesDataType":protected]=> string(5) "array" 
	   		["attendeesOmitted"]=> NULL 
	   		["colorId"]=> NULL 
	   		["created"]=> string(24) "2016-07-23T04:11:30.000Z" 
	   		["creatorType":protected]=> string(36) "Google_Service_Calendar_EventCreator" 
	   		["creatorDataType":protected]=> string(0) "" 
	   		["description"]=> string(23) "event notification tets" 
	   		["endType":protected]=> string(37) "Google_Service_Calendar_EventDateTime" 
	   		["endDataType":protected]=> string(0) "" 
	   		["endTimeUnspecified"]=> NULL 
	   		["etag"]=> string(18) ""2938494181492000"" 
	   		["extendedPropertiesType":protected]=> string(47) "Google_Service_Calendar_EventExtendedProperties" 
	   		["extendedPropertiesDataType":protected]=> string(0) "" 
	   		["gadgetType":protected]=> string(35) "Google_Service_Calendar_EventGadget" 
	   		["gadgetDataType":protected]=> string(0) "" 
	   		["guestsCanInviteOthers"]=> NULL 
	   		["guestsCanModify"]=> NULL 
	   		["guestsCanSeeOtherGuests"]=> NULL 
	   		["hangoutLink"]=> NULL 
	   		["htmlLink"]=> string(116) "https://www.google.com/calendar/event?eid=YnE0ZzZtdTc2NjRoamVuNGJjaWsxbnUydWsgZzRnZHE2ZDJ0dGpxZDI4YWNqaXFlNDEwbDBAZw" 
	   		["iCalUID"]=> string(37) "bq4g6mu7664hjen4bcik1nu2uk@google.com" 
	   		["id"]=> string(26) "bq4g6mu7664hjen4bcik1nu2uk" 
	   		["kind"]=> string(14) "calendar#event" 
	   		["location"]=> NULL 
	   		["locked"]=> NULL 
	   		["organizerType":protected]=> string(38) "Google_Service_Calendar_EventOrganizer" 
	   		["organizerDataType":protected]=> string(0) "" 
	   		["originalStartTimeType":protected]=> string(37) "Google_Service_Calendar_EventDateTime" 
	   		["originalStartTimeDataType":protected]=> string(0) "" 
	   		["privateCopy"]=> NULL 
	   		["recurrence"]=> NULL 
	   		["recurringEventId"]=> NULL 
	   		["remindersType":protected]=> string(38) "Google_Service_Calendar_EventReminders" 
	   		["remindersDataType":protected]=> string(0) "" 
	   		["sequence"]=> int(0) 
	   		["sourceType":protected]=> string(35) "Google_Service_Calendar_EventSource" 
	   		["sourceDataType":protected]=> string(0) "" 
	   		["startType":protected]=> string(37) "Google_Service_Calendar_EventDateTime" 
	   		["startDataType":protected]=> string(0) "" 
	   		["status"]=> string(9) "confirmed" 
	   		["summary"]=> string(37) "event notification test - (Interview)" 
	   		["transparency"]=> NULL 
	   		["updated"]=> string(24) "2016-07-23T04:11:30.798Z" 
	   		["visibility"]=> NULL 
	   		["modelData":protected]=> array(6) { 
	   			["creator"]=> array(1) { 
	   				["email"]=> string(50) "ekwa-hrm-calendar@ekwa-hrm.iam.gserviceaccount.com" } 
	   			["organizer"]=> array(3) { 
	   				["email"]=> string(52) "g4gdq6d2ttjqd28acjiqe410l0@group.calendar.google.com" 
	   				["displayName"]=> string(17) "Ekwa HRM Calendar" 
	   				["self"]=> bool(true) } 
	   			["start"]=> array(2) { 
	   				["dateTime"]=> string(25) "2016-07-23T09:45:00+05:30" 
	   				["timeZone"]=> string(12) "Asia/Colombo" } 
	   				["end"]=> array(2) { 
	   					["dateTime"]=> string(25) "2016-07-23T10:41:00+05:30" 
	   					["timeZone"]=> string(12) "Asia/Colombo" } 
	   				["attendees"]=> array(2) { 
	   					[0]=> array(3) { 
	   						["email"]=> string(15) "roshan@ekwa.com" 
	   						["displayName"]=> string(13) "Roshan Ruzaik" 
	   						["responseStatus"]=> string(11) "needsAction" } 
	   					[1]=> array(2) { 
	   						["email"]=> string(19) "mrmroshan@yahoo.com" 
	   						["responseStatus"]=> string(11) "needsAction" }
	   					} 
	   			["reminders"]=> array(2) { 
	   				["useDefault"]=> bool(false) 
	   				["overrides"]=> array(2) { 
	   					[0]=> array(2) { 
	   						["method"]=> string(5) "email" 
	   						["minutes"]=> int(1440) } 
	   					[1]=> array(2) { 
	   						["method"]=> string(5) "popup" 
	   						["minutes"]=> int(10) } 
	   						} 
	   					} 
	   				} 
	   			["processed":protected]=> array(0) { } }
	   		*/
	   		$optParams['sendNotifications'] = true;
	   		$event_obj = $this->google_calendar->events->insert($calendarId, $event,$optParams);
	   		return $event_obj;	
	   		//return $this->google_calendar->events->patch($calendarId,$event_obj->getId(),$event, $optParams );
		}//end if post
	}//end of function


	public function update_event($calendarId , $event_id,$event_data){
		$data = array();
		$calendarId = 'g4gdq6d2ttjqd28acjiqe410l0@group.calendar.google.com';	
		
		if(!empty($event_data)){
			$event_data["start_date"]	= str_replace(" ","T",$event_data["start_date"]);
			$event_data["end_date"]		= str_replace(" ","T",$event_data["end_date"]);
			
			$data = array(
				'summary' 		=> $event_data['summary'],
				'start' 		=> $event_data["start_date"].'+05:30',
				'end' 			=> $event_data["end_date"].'+05:30',
				'description' 	=> $event_data['description'],
				'attendees'     => $event_data['attendees']
			);
	    	//date format is => 2016-06-18T17:00:00+03:00
			
	    	$event = new Google_Service_Calendar_Event(
				array( 
					'summary' => $data['summary'],
					'description' => $data['description'],
					'start' => array('dateTime' => $data['start'], 'timeZone' => 'Asia/Colombo',),
					'end' => array('dateTime' => $data['end'], 'timeZone' => 'Asia/Colombo',),
					'attendees' => $data['attendees'],
					'reminders' => array(
						'useDefault' => false,
						'overrides' => array(
							array('method' => 'email', 'minutes' => 24 * 60),
							array('method' => 'popup', 'minutes' => 10),
						),
					),
				)
			);
	   		$optParams['sendNotifications'] = true;
	   		$updatedEvent = $this->google_calendar->events->update($calendarId, $event_id, $event,$optParams);
		}
	   	return $updatedEvent;	
	}//end of function


	public function get_event($calendarId,$event_id){
		$event = $this->google_calendar->events->get($calendarId, $event_id);
		return $event;
	}//end of function


	public function delete_event($calendarId,$event_id){
		$optParams['sendNotifications'] = true;
		$event = $this->google_calendar->events->delete($calendarId, $event_id,$optParams);		
		return $event;
	}//end of function


    public function list_events( $calendarId, $timeMin=false, $timeMax=false, $maxResults=10 ){
    	if(!$timeMin){
    		$timeMin = date("c", strtotime( date('Y-m-d ').' 00:00:00') );
    	}else{
    		$timeMin = date("c", strtotime( $timeMin) );
    	}
    		
    	if(!$timeMax){
    		//$timeMax = date("c", strtotime( date('Y-m-d ').' 23:59:59') );
    		$timeMax = date("c", strtotime( date('Y-m-d ',strtotime("+3 months", strtotime(date('Y-m-d')))).' 23:59:59') );
    	}else{
    		$timeMax = date("c", strtotime( $timeMax ) );
    	}

		$optParams = array(
			'maxResults' => $maxResults,
		  	'orderBy' => 'startTime',
		  	'singleEvents' => TRUE,
		  	'timeMin' => $timeMin,
		  	'timeMax' => $timeMax,
		  	'timeZone' => 'Europe/Istanbul'
		);
		$results = $this->google_calendar->events->listEvents($calendarId,$optParams);
		$data = array();

		foreach($results->getItems() as  $item){
			$start = date( 'd-m-Y H:i', strtotime( $item->getStart()->dateTime ) );
			array_push( 
				$data, array( 
					'id' 			=> $item->getId(),
					'summary'		=> $item->getSummary(),
					'description' 	=> $item->getDescription(),
					'creator'		=> $item->getCreator(),
					'start'			=> $item->getStart()->dateTime,
					'end'			=> $item->getEnd()->dateTime,
				)
			);
		}
		return $data;
    }//end of function
}